// home page - https://www.mql5.com/ru/users/vict
#ifndef VIM_HH
#define VIM_HH

#ifdef VIM
//--------------------------------------------------------------------
typedef unsigned uint;
typedef long datetime;
typedef unsigned short ushort;
typedef unsigned char uchar;
typedef unsigned long ulong;
typedef unsigned color;
#define interface struct
#define __DATETIME__ 0
#define __PATH__ ""
#define __FUNCTION__ ""
#define __FUNCSIG__ ""
#define __MQLBUILD__ 0
#define __MQL5BUILD__ 0
#define M_E 0
#define M_LOG2E 0
#define M_LOG10E 0
#define M_LN2 0
#define M_LN10 0
#define M_PI 0
#define M_PI_2 0
#define M_PI_4 0
#define M_1_PI 0
#define M_2_PI 0
#define M_2_SQRTPI 0
#define M_SQRT2 0
#define M_SQRT1_2 0
#define CHAR_MIN 0
#define CHAR_MAX 0
#define UCHAR_MAX 0
#define SHORT_MIN 0
#define SHORT_MAX 0
#define USHORT_MAX 0
#define INT_MIN 0
#define INT_MAX 0
#define UINT_MAX 0
#define LONG_MIN 0
#define LONG_MAX 0
#define ULONG_MAX 0
#define DBL_MIN 0
#define DBL_MAX 0
#define DBL_EPSILON 0
#define DBL_DIG 0
#define DBL_MANT_DIG 0
#define DBL_MAX_10_EXP 0
#define DBL_MAX_EXP 0
#define DBL_MIN_10_EXP 0
#define DBL_MIN_EXP 0
#define FLT_MIN 0
#define FLT_MAX 0
#define FLT_EPSILON 0
#define FLT_DIG 0
#define FLT_MANT_DIG 0
#define FLT_MAX_10_EXP 0
#define FLT_MAX_EXP 0
#define FLT_MIN_10_EXP 0
#define FLT_MIN_EXP 0
#define REASON_PROGRAM 0
#define REASON_REMOVE 0
#define REASON_RECOMPILE 0
#define REASON_CHARTCHANGE 0
#define REASON_CHARTCLOSE 0
#define REASON_PARAMETERS 0
#define REASON_ACCOUNT 0
#define REASON_TEMPLATE 0
#define REASON_INITFAILED 0
#define REASON_CLOSE 0
#define CHARTS_MAX 0
#define clrNONE 0
#define EMPTY_VALUE 0
#define INVALID_HANDLE 0
#define IS_DEBUG_MODE 0
#define IS_PROFILE_MODE 0
#define NULL 0
#define WHOLE_ARRAY 0
#define WRONG_VALUE 0

struct string
{
    string();
    string(const char*);
};
string operator+(const char*, const string &);
string operator+(const string &, const char*);
string operator+(const string &, const string &);
string &operator+=(const string &, const string &);
string &operator+=(const string &, const char*);
bool operator==(const string &, const string &);
bool operator!=(const string &, const string &);
bool operator==(const string &, const char*);
bool operator==(const char*, const string);
bool operator!=(const string &, const char*);
bool operator!=(const char*, const string);

enum ENUM_FILE_POSITION
{
    SEEK_CUR,
    SEEK_END,
    SEEK_SET
};
enum ENUM_OBJECT_PROPERTY_INTEGER
{
    OBJPROP_COLOR,
    OBJPROP_STYLE,
    OBJPROP_WIDTH,
    OBJPROP_BACK,
    OBJPROP_ZORDER,
    OBJPROP_FILL,
    OBJPROP_HIDDEN,
    OBJPROP_SELECTED,
    OBJPROP_READONLY,
    OBJPROP_TYPE,
    OBJPROP_TIME,
    OBJPROP_SELECTABLE,
    OBJPROP_CREATETIME,
    OBJPROP_LEVELS,
    OBJPROP_LEVELCOLOR,
    OBJPROP_LEVELSTYLE,
    OBJPROP_LEVELWIDTH,
    OBJPROP_ALIGN,
    OBJPROP_FONTSIZE,
    OBJPROP_RAY_LEFT,
    OBJPROP_RAY_RIGHT,
    OBJPROP_RAY,
    OBJPROP_ELLIPSE,
    OBJPROP_ARROWCODE,
    OBJPROP_TIMEFRAMES,
    OBJPROP_ANCHOR,
    OBJPROP_XDISTANCE,
    OBJPROP_YDISTANCE,
    OBJPROP_DIRECTION,
    OBJPROP_DEGREE,
    OBJPROP_DRAWLINES,
    OBJPROP_STATE,
    OBJPROP_CHART_ID,
    OBJPROP_XSIZE,
    OBJPROP_YSIZE,
    OBJPROP_XOFFSET,
    OBJPROP_YOFFSET,
    OBJPROP_PERIOD,
    OBJPROP_DATE_SCALE,
    OBJPROP_PRICE_SCALE,
    OBJPROP_CHART_SCALE,
    OBJPROP_BGCOLOR,
    OBJPROP_CORNER,
    OBJPROP_BORDER_TYPE,
    OBJPROP_BORDER_COLOR
};
enum ENUM_OBJECT_PROPERTY_DOUBLE
{
    OBJPROP_PRICE,
    OBJPROP_LEVELVALUE,
    OBJPROP_SCALE,
    OBJPROP_ANGLE,
    OBJPROP_DEVIATION
};
enum ENUM_OBJECT_PROPERTY_STRING
{
    OBJPROP_NAME,
    OBJPROP_TEXT,
    OBJPROP_TOOLTIP,
    OBJPROP_LEVELTEXT,
    OBJPROP_FONT,
    OBJPROP_BMPFILE,
    OBJPROP_SYMBOL
};
enum ENUM_BORDER_TYPE
{
    BORDER_FLAT,
    BORDER_RAISED,
    BORDER_SUNKEN
};
enum ENUM_ALIGN_MODE
{
    ALIGN_LEFT,
    ALIGN_CENTER,
    ALIGN_RIGHT
};
enum ENUM_CHART_EVENT
{
    CHARTEVENT_KEYDOWN,
    CHARTEVENT_MOUSE_MOVE,
    CHARTEVENT_MOUSE_WHEEL,
    CHARTEVENT_OBJECT_CREATE,
    CHARTEVENT_OBJECT_CHANGE,
    CHARTEVENT_OBJECT_DELETE,
    CHARTEVENT_CLICK,
    CHARTEVENT_OBJECT_CLICK,
    CHARTEVENT_OBJECT_DRAG,
    CHARTEVENT_OBJECT_ENDEDIT,
    CHARTEVENT_CHART_CHANGE,
    CHARTEVENT_CUSTOM,
    CHARTEVENT_CUSTOM_LAST
};
enum ENUM_TIMEFRAMES
{
    PERIOD_CURRENT,
    PERIOD_M1,
    PERIOD_M2,
    PERIOD_M3,
    PERIOD_M4,
    PERIOD_M5,
    PERIOD_M6,
    PERIOD_M10,
    PERIOD_M12,
    PERIOD_M15,
    PERIOD_M20,
    PERIOD_M30,
    PERIOD_H1,
    PERIOD_H2,
    PERIOD_H3,
    PERIOD_H4,
    PERIOD_H6,
    PERIOD_H8,
    PERIOD_H12,
    PERIOD_D1,
    PERIOD_W1,
    PERIOD_MN1
};
enum ENUM_SERIESMODE
{
    MODE_OPEN,
    MODE_LOW,
    MODE_HIGH,
    MODE_CLOSE,
    MODE_VOLUME,
    MODE_REAL_VOLUME,
    MODE_SPREAD
};
enum ENUM_CHART_PROPERTY_INTEGER
{
    CHART_SHOW,
    CHART_IS_OBJECT,
    CHART_BRING_TO_TOP,
    CHART_CONTEXT_MENU,
    CHART_CROSSHAIR_TOOL,
    CHART_MOUSE_SCROLL,
    CHART_EVENT_MOUSE_WHEEL,
    CHART_EVENT_MOUSE_MOVE,
    CHART_EVENT_OBJECT_CREATE,
    CHART_EVENT_OBJECT_DELETE,
    CHART_MODE,
    CHART_FOREGROUND,
    CHART_SHIFT,
    CHART_AUTOSCROLL,
    CHART_KEYBOARD_CONTROL,
    CHART_QUICK_NAVIGATION,
    CHART_SCALE,
    CHART_SCALEFIX,
    CHART_SCALEFIX_11,
    CHART_SCALE_PT_PER_BAR,
    CHART_SHOW_OHLC,
    CHART_SHOW_BID_LINE,
    CHART_SHOW_ASK_LINE,
    CHART_SHOW_LAST_LINE,
    CHART_SHOW_PERIOD_SEP,
    CHART_SHOW_GRID,
    CHART_SHOW_VOLUMES,
    CHART_SHOW_OBJECT_DESCR,
    CHART_VISIBLE_BARS,
    CHART_WINDOWS_TOTAL,
    CHART_WINDOW_IS_VISIBLE,
    CHART_WINDOW_HANDLE,
    CHART_WINDOW_YDISTANCE,
    CHART_FIRST_VISIBLE_BAR,
    CHART_WIDTH_IN_BARS,
    CHART_WIDTH_IN_PIXELS,
    CHART_HEIGHT_IN_PIXELS,
    CHART_COLOR_BACKGROUND,
    CHART_COLOR_FOREGROUND,
    CHART_COLOR_GRID,
    CHART_COLOR_VOLUME,
    CHART_COLOR_CHART_UP,
    CHART_COLOR_CHART_DOWN,
    CHART_COLOR_CHART_LINE,
    CHART_COLOR_CANDLE_BULL,
    CHART_COLOR_CANDLE_BEAR,
    CHART_COLOR_BID,
    CHART_COLOR_ASK,
    CHART_COLOR_LAST,
    CHART_COLOR_STOP_LEVEL,
    CHART_SHOW_TRADE_LEVELS,
    CHART_DRAG_TRADE_LEVELS,
    CHART_SHOW_DATE_SCALE,
    CHART_SHOW_PRICE_SCALE,
    CHART_SHOW_ONE_CLICK,
    CHART_IS_MAXIMIZED,
    CHART_IS_MINIMIZED,
    CHART_IS_DOCKED,
    CHART_FLOAT_LEFT,
    CHART_FLOAT_TOP,
    CHART_FLOAT_RIGHT,
    CHART_FLOAT_BOTTOM
};
enum ENUM_CHART_PROPERTY_DOUBLE
{
    CHART_SHIFT_SIZE,
    CHART_FIXED_POSITION,
    CHART_FIXED_MAX,
    CHART_FIXED_MIN,
    CHART_POINTS_PER_BAR,
    CHART_PRICE_MIN,
    CHART_PRICE_MAX
};
enum ENUM_CHART_PROPERTY_STRING
{
    CHART_COMMENT,
    CHART_EXPERT_NAME,
    CHART_SCRIPT_NAME
};
enum ENUM_CHART_POSITION
{
    CHART_BEGIN,
    CHART_CURRENT_POS,
    CHART_END
};
enum ENUM_CHART_MODE
{
    CHART_BARS,
    CHART_CANDLES,
    CHART_LINE
};
enum ENUM_CHART_VOLUME_MODE
{
    CHART_VOLUME_HIDE,
    CHART_VOLUME_TICK,
    CHART_VOLUME_REAL
};
enum ENUM_OBJECT
{
    OBJ_VLINE,
    OBJ_HLINE,
    OBJ_TREND,
    OBJ_TRENDBYANGLE,
    OBJ_CYCLES,
    OBJ_ARROWED_LINE,
    OBJ_CHANNEL,
    OBJ_STDDEVCHANNEL,
    OBJ_REGRESSION,
    OBJ_PITCHFORK,
    OBJ_GANNLINE,
    OBJ_GANNFAN,
    OBJ_GANNGRID,
    OBJ_FIBO,
    OBJ_FIBOTIMES,
    OBJ_FIBOFAN,
    OBJ_FIBOARC,
    OBJ_FIBOCHANNEL,
    OBJ_EXPANSION,
    OBJ_ELLIOTWAVE5,
    OBJ_ELLIOTWAVE3,
    OBJ_RECTANGLE,
    OBJ_TRIANGLE,
    OBJ_ELLIPSE,
    OBJ_ARROW_THUMB_UP,
    OBJ_ARROW_THUMB_DOWN,
    OBJ_ARROW_UP,
    OBJ_ARROW_DOWN,
    OBJ_ARROW_STOP,
    OBJ_ARROW_CHECK,
    OBJ_ARROW_LEFT_PRICE,
    OBJ_ARROW_RIGHT_PRICE,
    OBJ_ARROW_BUY,
    OBJ_ARROW_SELL,
    OBJ_ARROW,
    OBJ_TEXT,
    OBJ_LABEL,
    OBJ_BUTTON,
    OBJ_CHART,
    OBJ_BITMAP,
    OBJ_BITMAP_LABEL,
    OBJ_EDIT,
    OBJ_EVENT,
    OBJ_RECTANGLE_LABEL
};
enum ENUM_ANCHOR_POINT
{
    ANCHOR_LEFT_UPPER,
    ANCHOR_LEFT,
    ANCHOR_LEFT_LOWER,
    ANCHOR_LOWER,
    ANCHOR_RIGHT_LOWER,
    ANCHOR_RIGHT,
    ANCHOR_RIGHT_UPPER,
    ANCHOR_UPPER,
    ANCHOR_CENTER
};
enum ENUM_ARROW_ANCHOR
{
    ANCHOR_TOP,
    ANCHOR_BOTTOM,
};
enum ENUM_BASE_CORNER
{
    CORNER_LEFT_UPPER,
    CORNER_LEFT_LOWER,
    CORNER_RIGHT_LOWER,
    CORNER_RIGHT_UPPER
};
enum ENUM_ELLIOT_WAVE_DEGREE
{
    ELLIOTT_GRAND_SUPERCYCLE,
    ELLIOTT_SUPERCYCLE,
    ELLIOTT_CYCLE,
    ELLIOTT_PRIMARY,
    ELLIOTT_INTERMEDIATE,
    ELLIOTT_MINOR,
    ELLIOTT_MINUTE,
    ELLIOTT_MINUETTE,
    ELLIOTT_SUBMINUETTE
};
enum ENUM_GANN_DIRECTION
{
    GANN_UP_TREND,
    GANN_DOWN_TREND
};
enum ENUM_APPLIED_PRICE
{
    PRICE_CLOSE,
    PRICE_OPEN,
    PRICE_HIGH,
    PRICE_LOW,
    PRICE_MEDIAN,
    PRICE_TYPICAL,
    PRICE_WEIGHTED
};
enum ENUM_APPLIED_VOLUME
{
    VOLUME_TICK,
    VOLUME_REAL
};
enum ENUM_STO_PRICE
{
    STO_LOWHIGH,
    STO_CLOSECLOSE
};
enum ENUM_MA_METHOD
{
    MODE_SMA,
    MODE_EMA,
    MODE_SMMA,
    MODE_LWMA
};
enum ENUM_DRAW_TYPE
{
    DRAW_NONE,
    DRAW_LINE,
    DRAW_SECTION,
    DRAW_HISTOGRAM,
    DRAW_HISTOGRAM2,
    DRAW_ARROW,
    DRAW_ZIGZAG,
    DRAW_FILLING,
    DRAW_BARS,
    DRAW_CANDLES,
    DRAW_COLOR_LINE,
    DRAW_COLOR_SECTION,
    DRAW_COLOR_HISTOGRAM,
    DRAW_COLOR_HISTOGRAM2,
    DRAW_COLOR_ARROW,
    DRAW_COLOR_ZIGZAG,
    DRAW_COLOR_BARS,
    DRAW_COLOR_CANDLES
};
enum ENUM_PLOT_PROPERTY_INTEGER
{
    PLOT_ARROW,
    PLOT_DRAW_BEGIN,
    PLOT_DRAW_TYPE,
    ENUM_DRAW_TYPE,
    PLOT_SHOW_DATA,
    PLOT_SHIFT,
    PLOT_LINE_STYLE,
    ENUM_LINE_STYLE,
    PLOT_LINE_WIDTH,
    PLOT_COLOR_INDEXES,
    PLOT_LINE_COLOR
};
enum ENUM_PLOT_PROPERTY_DOUBLE
{
    PLOT_EMPTY_VALUE
};
enum ENUM_PLOT_PROPERTY_STRING
{
    PLOT_LABEL
};
enum ENUM_LINE_STYLE
{
    STYLE_SOLID,
    STYLE_DASH,
    STYLE_DOT,
    STYLE_DASHDOT,
    STYLE_DASHDOTDOT
};
enum ENUM_INDEXBUFFER_TYPE
{
    INDICATOR_DATA,
    INDICATOR_COLOR_INDEX,
    INDICATOR_CALCULATIONS
};
enum ENUM_CUSTOMIND_PROPERTY_INTEGER
{
    INDICATOR_DIGITS,
    INDICATOR_HEIGHT,
    INDICATOR_LEVELS,
    INDICATOR_LEVELCOLOR,
    INDICATOR_LEVELSTYLE,
    INDICATOR_LEVELWIDTH
};
enum ENUM_CUSTOMIND_PROPERTY_DOUBLE
{
    INDICATOR_MINIMUM,
    INDICATOR_MAXIMUM,
    INDICATOR_LEVELVALUE
};
enum ENUM_CUSTOMIND_PROPERTY_STRING
{
    INDICATOR_SHORTNAME,
    INDICATOR_LEVELTEXT
};
enum ENUM_INDICATOR
{
    IND_AC,
    IND_AD,
    IND_ADX,
    IND_ADXW,
    IND_ALLIGATOR,
    IND_AMA,
    IND_AO,
    IND_ATR,
    IND_BANDS,
    IND_BEARS,
    IND_BULLS,
    IND_BWMFI,
    IND_CCI,
    IND_CHAIKIN,
    IND_CUSTOM,
    IND_DEMA,
    IND_DEMARKER,
    IND_ENVELOPES,
    IND_FORCE,
    IND_FRACTALS,
    IND_FRAMA,
    IND_GATOR,
    IND_ICHIMOKU,
    IND_MA,
    IND_MACD,
    IND_MFI,
    IND_MOMENTUM,
    IND_OBV,
    IND_OSMA,
    IND_RSI,
    IND_RVI,
    IND_SAR,
    IND_STDDEV,
    IND_STOCHASTIC,
    IND_TEMA,
    IND_TRIX,
    IND_VIDYA,
    IND_VOLUMES,
    IND_WPR
};
enum ENUM_DATATYPE
{
    TYPE_BOOL,
    TYPE_CHAR,
    TYPE_UCHAR,
    TYPE_SHORT,
    TYPE_USHORT,
    TYPE_COLOR,
    TYPE_INT,
    TYPE_UINT,
    TYPE_DATETIME,
    TYPE_LONG,
    TYPE_ULONG,
    TYPE_FLOAT,
    TYPE_DOUBLE,
    TYPE_STRING
};
enum ENUM_TERMINAL_INFO_INTEGER
{
    TERMINAL_BUILD,
    TERMINAL_COMMUNITY_ACCOUNT,
    TERMINAL_COMMUNITY_CONNECTION,
    TERMINAL_CONNECTED,
    TERMINAL_DLLS_ALLOWED,
    TERMINAL_TRADE_ALLOWED,
    TERMINAL_EMAIL_ENABLED,
    TERMINAL_FTP_ENABLED,
    TERMINAL_NOTIFICATIONS_ENABLED,
    TERMINAL_MAXBARS,
    TERMINAL_MQID,
    TERMINAL_CODEPAGE,
    TERMINAL_CPU_CORES,
    TERMINAL_DISK_SPACE,
    TERMINAL_MEMORY_PHYSICAL,
    TERMINAL_MEMORY_TOTAL,
    TERMINAL_MEMORY_AVAILABLE,
    TERMINAL_MEMORY_USED,
    TERMINAL_X64,
    TERMINAL_OPENCL_SUPPORT,
    TERMINAL_SCREEN_DPI,
    TERMINAL_SCREEN_LEFT,
    TERMINAL_SCREEN_TOP,
    TERMINAL_SCREEN_WIDTH,
    TERMINAL_SCREEN_HEIGHT,
    TERMINAL_LEFT,
    TERMINAL_TOP,
    TERMINAL_RIGHT,
    TERMINAL_BOTTOM,
    TERMINAL_PING_LAST,
    TERMINAL_VPS,
    TERMINAL_KEYSTATE_LEFT,
    TERMINAL_KEYSTATE_UP,
    TERMINAL_KEYSTATE_RIGHT,
    TERMINAL_KEYSTATE_DOWN,
    TERMINAL_KEYSTATE_SHIFT,
    TERMINAL_KEYSTATE_CONTROL,
    TERMINAL_KEYSTATE_MENU,
    TERMINAL_KEYSTATE_CAPSLOCK,
    TERMINAL_KEYSTATE_NUMLOCK,
    TERMINAL_KEYSTATE_SCRLOCK,
    TERMINAL_KEYSTATE_ENTER,
    TERMINAL_KEYSTATE_INSERT,
    TERMINAL_KEYSTATE_DELETE,
    TERMINAL_KEYSTATE_HOME,
    TERMINAL_KEYSTATE_END,
    TERMINAL_KEYSTATE_TAB,
    TERMINAL_KEYSTATE_PAGEUP,
    TERMINAL_KEYSTATE_PAGEDOWN,
    TERMINAL_KEYSTATE_ESCAPE
};
enum ENUM_TERMINAL_INFO_DOUBLE
{
    TERMINAL_COMMUNITY_BALANCE,
    TERMINAL_RETRANSMISSION
};
enum ENUM_TERMINAL_INFO_STRING
{
    TERMINAL_LANGUAGE,
    TERMINAL_COMPANY,
    TERMINAL_NAME,
    TERMINAL_PATH,
    TERMINAL_DATA_PATH,
    TERMINAL_COMMONDATA_PATH
};
enum ENUM_MQL_INFO_INTEGER
{
    MQL_MEMORY_LIMIT,
    MQL_MEMORY_USED,
    MQL_PROGRAM_TYPE,
    MQL_DLLS_ALLOWED,
    MQL_TRADE_ALLOWED,
    MQL_SIGNALS_ALLOWED,
    MQL_DEBUG,
    MQL_PROFILER,
    MQL_TESTER,
    MQL_FORWARD,
    MQL_OPTIMIZATION,
    MQL_VISUAL_MODE,
    MQL_FRAME_MODE,
    MQL_LICENSE_TYPE
};
enum ENUM_MQL_INFO_STRING
{
    MQL_PROGRAM_NAME,
    MQL_PROGRAM_PATH
};
enum ENUM_PROGRAM_TYPE
{
    PROGRAM_SCRIPT,
    PROGRAM_EXPERT,
    PROGRAM_INDICATOR
};
enum ENUM_LICENSE_TYPE
{
    LICENSE_FREE,
    LICENSE_DEMO,
    LICENSE_FULL,
    LICENSE_TIME
};
enum ENUM_SYMBOL_INFO_INTEGER
{
    SYMBOL_CUSTOM,
    SYMBOL_BACKGROUND_COLOR,
    SYMBOL_CHART_MODE,
    SYMBOL_EXIST,
    SYMBOL_SELECT,
    SYMBOL_VISIBLE,
    SYMBOL_SESSION_DEALS,
    SYMBOL_SESSION_BUY_ORDERS,
    SYMBOL_SESSION_SELL_ORDERS,
    SYMBOL_VOLUME,
    SYMBOL_VOLUMEHIGH,
    SYMBOL_VOLUMELOW,
    SYMBOL_TIME,
    SYMBOL_DIGITS,
    SYMBOL_SPREAD,
    SYMBOL_SPREAD_FLOAT,
    SYMBOL_TICKS_BOOKDEPTH,
    SYMBOL_TRADE_CALC_MODE,
    SYMBOL_TRADE_MODE,
    SYMBOL_START_TIME,
    SYMBOL_EXPIRATION_TIME,
    SYMBOL_TRADE_STOPS_LEVEL,
    SYMBOL_TRADE_FREEZE_LEVEL,
    SYMBOL_TRADE_EXEMODE,
    SYMBOL_SWAP_MODE,
    SYMBOL_SWAP_ROLLOVER3DAYS,
    SYMBOL_MARGIN_HEDGED_USE_LEG,
    SYMBOL_EXPIRATION_MODE,
    SYMBOL_FILLING_MODE,
    SYMBOL_ORDER_MODE,
    SYMBOL_ORDER_GTC_MODE,
    SYMBOL_OPTION_MODE,
    SYMBOL_OPTION_RIGHT
};
enum ENUM_SYMBOL_INFO_DOUBLE
{
    SYMBOL_BID,
    SYMBOL_BIDHIGH,
    SYMBOL_BIDLOW,
    SYMBOL_ASK,
    SYMBOL_ASKHIGH,
    SYMBOL_ASKLOW,
    SYMBOL_LAST,
    SYMBOL_LASTHIGH,
    SYMBOL_LASTLOW,
    SYMBOL_VOLUME_REAL,
    SYMBOL_VOLUMEHIGH_REAL,
    SYMBOL_VOLUMELOW_REAL,
    SYMBOL_OPTION_STRIKE,
    SYMBOL_POINT,
    SYMBOL_TRADE_TICK_VALUE,
    SYMBOL_TRADE_TICK_VALUE_PROFIT,
    SYMBOL_TRADE_TICK_VALUE_LOSS,
    SYMBOL_TRADE_TICK_SIZE,
    SYMBOL_TRADE_CONTRACT_SIZE,
    SYMBOL_TRADE_ACCRUED_INTEREST,
    SYMBOL_TRADE_FACE_VALUE,
    SYMBOL_TRADE_LIQUIDITY_RATE,
    SYMBOL_VOLUME_MIN,
    SYMBOL_VOLUME_MAX,
    SYMBOL_VOLUME_STEP,
    SYMBOL_VOLUME_LIMIT,
    SYMBOL_SWAP_LONG,
    SYMBOL_SWAP_SHORT,
    SYMBOL_MARGIN_INITIAL,
    SYMBOL_MARGIN_MAINTENANCE,
    SYMBOL_SESSION_VOLUME,
    SYMBOL_SESSION_TURNOVER,
    SYMBOL_SESSION_INTEREST,
    SYMBOL_SESSION_BUY_ORDERS_VOLUME,
    SYMBOL_SESSION_SELL_ORDERS_VOLUME,
    SYMBOL_SESSION_OPEN,
    SYMBOL_SESSION_CLOSE,
    SYMBOL_SESSION_AW,
    SYMBOL_SESSION_PRICE_SETTLEMENT,
    SYMBOL_SESSION_PRICE_LIMIT_MIN,
    SYMBOL_SESSION_PRICE_LIMIT_MAX,
    SYMBOL_MARGIN_HEDGED
};
enum ENUM_SYMBOL_INFO_STRING
{
    SYMBOL_BASIS,
    SYMBOL_CATEGORY,
    SYMBOL_CURRENCY_BASE,
    SYMBOL_CURRENCY_PROFIT,
    SYMBOL_CURRENCY_MARGIN,
    SYMBOL_BANK,
    SYMBOL_DESCRIPTION,
    SYMBOL_EXCHANGE,
    SYMBOL_FORMULA,
    SYMBOL_ISIN,
    SYMBOL_PAGE,
    SYMBOL_PATH
};
enum ENUM_SYMBOL_CHART_MODE
{
    SYMBOL_CHART_MODE_BID,
    SYMBOL_CHART_MODE_LAST
};
enum ENUM_SYMBOL_ORDER_GTC_MODE
{
    SYMBOL_ORDERS_GTC,
    SYMBOL_ORDERS_DAILY,
    SYMBOL_ORDERS_DAILY_EXCLUDING_STOPS
};
enum ENUM_SYMBOL_CALC_MODE
{
    SYMBOL_CALC_MODE_FOREX,
    SYMBOL_CALC_MODE_FOREX_NO_LEVERAGE,
    SYMBOL_CALC_MODE_FUTURES,
    SYMBOL_CALC_MODE_CFD,
    SYMBOL_CALC_MODE_CFDINDEX,
    SYMBOL_CALC_MODE_CFDLEVERAGE,
    SYMBOL_CALC_MODE_EXCH_STOCKS,
    SYMBOL_CALC_MODE_EXCH_FUTURES,
    SYMBOL_CALC_MODE_EXCH_FUTURES_FORTS,
    SYMBOL_CALC_MODE_EXCH_BONDS,
    SYMBOL_CALC_MODE_EXCH_STOCKS_MOEX,
    SYMBOL_CALC_MODE_EXCH_BONDS_MOEX,
    SYMBOL_CALC_MODE_SERV_COLLATERAL
};
enum ENUM_SYMBOL_TRADE_MODE
{
    SYMBOL_TRADE_MODE_DISABLED,
    SYMBOL_TRADE_MODE_LONGONLY,
    SYMBOL_TRADE_MODE_SHORTONLY,
    SYMBOL_TRADE_MODE_CLOSEONLY,
    SYMBOL_TRADE_MODE_FULL
};
enum ENUM_SYMBOL_TRADE_EXECUTION
{
    SYMBOL_TRADE_EXECUTION_REQUEST,
    SYMBOL_TRADE_EXECUTION_INSTANT,
    SYMBOL_TRADE_EXECUTION_MARKET,
    SYMBOL_TRADE_EXECUTION_EXCHANGE
};
enum ENUM_SYMBOL_SWAP_MODE
{
    SYMBOL_SWAP_MODE_DISABLED,
    SYMBOL_SWAP_MODE_POINTS,
    SYMBOL_SWAP_MODE_CURRENCY_SYMBOL,
    SYMBOL_SWAP_MODE_CURRENCY_MARGIN,
    SYMBOL_SWAP_MODE_CURRENCY_DEPOSIT,
    SYMBOL_SWAP_MODE_INTEREST_CURRENT,
    SYMBOL_SWAP_MODE_INTEREST_OPEN,
    SYMBOL_SWAP_MODE_REOPEN_CURRENT,
    SYMBOL_SWAP_MODE_REOPEN_BID
};
enum ENUM_DAY_OF_WEEK
{
    SUNDAY,
    MONDAY,
    TUESDAY,
    WEDNESDAY,
    THURSDAY,
    FRIDAY,
    SATURDAY
};
enum ENUM_SYMBOL_OPTION_RIGHT
{
    SYMBOL_OPTION_RIGHT_CALL,
    SYMBOL_OPTION_RIGHT_PUT
};
enum ENUM_SYMBOL_OPTION_MODE
{
    SYMBOL_OPTION_MODE_EUROPEAN,
    SYMBOL_OPTION_MODE_AMERICAN
};
enum ENUM_ACCOUNT_INFO_INTEGER
{
    ACCOUNT_LOGIN,
    ACCOUNT_TRADE_MODE,
    ACCOUNT_LEVERAGE,
    ACCOUNT_LIMIT_ORDERS,
    ACCOUNT_MARGIN_SO_MODE,
    ACCOUNT_TRADE_ALLOWED,
    ACCOUNT_TRADE_EXPERT,
    ACCOUNT_MARGIN_MODE,
    ACCOUNT_CURRENCY_DIGITS,
    ACCOUNT_FIFO_CLOSE
};
enum ENUM_ACCOUNT_INFO_DOUBLE
{
    ACCOUNT_BALANCE,
    ACCOUNT_CREDIT,
    ACCOUNT_PROFIT,
    ACCOUNT_EQUITY,
    ACCOUNT_MARGIN,
    ACCOUNT_MARGIN_FREE,
    ACCOUNT_MARGIN_LEVEL,
    ACCOUNT_MARGIN_SO_CALL,
    ACCOUNT_MARGIN_SO_SO,
    ACCOUNT_MARGIN_INITIAL,
    ACCOUNT_MARGIN_MAINTENANCE,
    ACCOUNT_ASSETS,
    ACCOUNT_LIABILITIES,
    ACCOUNT_COMMISSION_BLOCKED
};
enum ENUM_ACCOUNT_INFO_STRING
{
    ACCOUNT_NAME,
    ACCOUNT_SERVER,
    ACCOUNT_CURRENCY,
    ACCOUNT_COMPANY
};
enum ENUM_ACCOUNT_TRADE_MODE
{
    ACCOUNT_TRADE_MODE_DEMO,
    ACCOUNT_TRADE_MODE_CONTEST,
    ACCOUNT_TRADE_MODE_REAL
};
enum ENUM_ACCOUNT_STOPOUT_MODE
{
    ACCOUNT_STOPOUT_MODE_PERCENT,
    ACCOUNT_STOPOUT_MODE_MONEY
};
enum ENUM_ACCOUNT_MARGIN_MODE
{
    ACCOUNT_MARGIN_MODE_RETAIL_NETTING,
    ACCOUNT_MARGIN_MODE_EXCHANGE,
    ACCOUNT_MARGIN_MODE_RETAIL_HEDGING
};
enum ENUM_STATISTICS
{
    STAT_INITIAL_DEPOSIT,
    STAT_WITHDRAWAL,
    STAT_PROFIT,
    STAT_GROSS_PROFIT,
    STAT_GROSS_LOSS,
    STAT_MAX_PROFITTRADE,
    STAT_MAX_LOSSTRADE,
    STAT_CONPROFITMAX,
    STAT_CONPROFITMAX_TRADES,
    STAT_MAX_CONWINS,
    STAT_MAX_CONPROFIT_TRADES,
    STAT_CONLOSSMAX,
    STAT_CONLOSSMAX_TRADES,
    STAT_MAX_CONLOSSES,
    STAT_MAX_CONLOSS_TRADES,
    STAT_BALANCEMIN,
    STAT_BALANCE_DD,
    STAT_BALANCEDD_PERCENT,
    STAT_BALANCE_DDREL_PERCENT,
    STAT_BALANCE_DD_RELATIVE,
    STAT_EQUITYMIN,
    STAT_EQUITY_DD,
    STAT_EQUITYDD_PERCENT,
    STAT_EQUITY_DDREL_PERCENT,
    STAT_EQUITY_DD_RELATIVE,
    STAT_EXPECTED_PAYOFF,
    STAT_PROFIT_FACTOR,
    STAT_RECOVERY_FACTOR,
    STAT_SHARPE_RATIO,
    STAT_MIN_MARGINLEVEL,
    STAT_CUSTOM_ONTESTER,
    STAT_DEALS,
    STAT_TRADES,
    STAT_PROFIT_TRADES,
    STAT_LOSS_TRADES,
    STAT_SHORT_TRADES,
    STAT_LONG_TRADES,
    STAT_PROFIT_SHORTTRADES,
    STAT_PROFIT_LONGTRADES,
    STAT_PROFITTRADES_AVGCON,
    STAT_LOSSTRADES_AVGCON
};
enum ENUM_SERIES_INFO_INTEGER
{
    SERIES_BARS_COUNT,
    SERIES_FIRSTDATE,
    SERIES_LASTBAR_DATE,
    SERIES_SERVER_FIRSTDATE,
    SERIES_TERMINAL_FIRSTDATE,
    SERIES_SYNCHRONIZED
};
enum ENUM_ORDER_PROPERTY_INTEGER
{
    ORDER_TICKET,
    ORDER_TIME_SETUP,
    ORDER_TYPE,
    ORDER_STATE,
    ORDER_TIME_EXPIRATION,
    ORDER_TIME_DONE,
    ORDER_TIME_SETUP_MSC,
    ORDER_TIME_DONE_MSC,
    ORDER_TYPE_FILLING,
    ORDER_TYPE_TIME,
    ORDER_MAGIC,
    ORDER_REASON,
    ORDER_POSITION_ID,
    ORDER_POSITION_BY_ID
};
enum ENUM_ORDER_PROPERTY_DOUBLE
{
    ORDER_VOLUME_INITIAL,
    ORDER_VOLUME_CURRENT,
    ORDER_PRICE_OPEN,
    ORDER_SL,
    ORDER_TP,
    ORDER_PRICE_CURRENT,
    ORDER_PRICE_STOPLIMIT
};
enum ENUM_ORDER_PROPERTY_STRING
{
    ORDER_SYMBOL,
    ORDER_COMMENT,
    ORDER_EXTERNAL_ID
};
enum ENUM_ORDER_TYPE
{
    ORDER_TYPE_BUY,
    ORDER_TYPE_SELL,
    ORDER_TYPE_BUY_LIMIT,
    ORDER_TYPE_SELL_LIMIT,
    ORDER_TYPE_BUY_STOP,
    ORDER_TYPE_SELL_STOP,
    ORDER_TYPE_BUY_STOP_LIMIT,
    ORDER_TYPE_SELL_STOP_LIMIT,
    ORDER_TYPE_CLOSE_BY
};
enum ENUM_ORDER_STATE
{
    ORDER_STATE_STARTED,
    ORDER_STATE_PLACED,
    ORDER_STATE_CANCELED,
    ORDER_STATE_PARTIAL,
    ORDER_STATE_FILLED,
    ORDER_STATE_REJECTED,
    ORDER_STATE_EXPIRED,
    ORDER_STATE_REQUEST_ADD,
    ORDER_STATE_REQUEST_MODIFY,
    ORDER_STATE_REQUEST_CANCEL
};
enum ENUM_ORDER_TYPE_FILLING
{
    ORDER_FILLING_FOK,
    ORDER_FILLING_IOC,
    ORDER_FILLING_RETURN
};
enum ENUM_ORDER_TYPE_TIME
{
    ORDER_TIME_GTC,
    ORDER_TIME_DAY,
    ORDER_TIME_SPECIFIED,
    ORDER_TIME_SPECIFIED_DAY
};
enum ENUM_ORDER_REASON
{
    ORDER_REASON_CLIENT,
    ORDER_REASON_MOBILE,
    ORDER_REASON_WEB,
    ORDER_REASON_EXPERT,
    ORDER_REASON_SL,
    ORDER_REASON_TP,
    ORDER_REASON_SO
};
enum ENUM_POSITION_PROPERTY_INTEGER
{
    POSITION_TICKET,
    POSITION_TIME,
    POSITION_TIME_MSC,
    POSITION_TIME_UPDATE,
    POSITION_TIME_UPDATE_MSC,
    POSITION_TYPE,
    POSITION_MAGIC,
    POSITION_IDENTIFIER,
    POSITION_REASON
};
enum ENUM_POSITION_PROPERTY_DOUBLE
{
    POSITION_VOLUME,
    POSITION_PRICE_OPEN,
    POSITION_SL,
    POSITION_TP,
    POSITION_PRICE_CURRENT,
    POSITION_SWAP,
    POSITION_PROFIT
};
enum ENUM_POSITION_PROPERTY_STRING
{
    POSITION_SYMBOL,
    POSITION_COMMENT,
    POSITION_EXTERNAL_ID
};
enum ENUM_POSITION_TYPE
{
    POSITION_TYPE_BUY,
    POSITION_TYPE_SELL
};
enum ENUM_POSITION_REASON
{
    POSITION_REASON_CLIENT,
    POSITION_REASON_MOBILE,
    POSITION_REASON_WEB,
    POSITION_REASON_EXPERT
};
enum ENUM_DEAL_PROPERTY_INTEGER
{
    DEAL_TICKET,
    DEAL_ORDER,
    DEAL_TIME,
    DEAL_TIME_MSC,
    DEAL_TYPE,
    DEAL_ENTRY,
    DEAL_MAGIC,
    DEAL_REASON,
    DEAL_POSITION_ID
};
enum ENUM_DEAL_PROPERTY_DOUBLE
{
    DEAL_VOLUME,
    DEAL_PRICE,
    DEAL_COMMISSION,
    DEAL_SWAP,
    DEAL_PROFIT
};
enum ENUM_DEAL_PROPERTY_STRING
{
    DEAL_SYMBOL,
    DEAL_COMMENT,
    DEAL_EXTERNAL_ID
};
enum ENUM_DEAL_TYPE
{
    DEAL_TYPE_BUY,
    DEAL_TYPE_SELL,
    DEAL_TYPE_BALANCE,
    DEAL_TYPE_CREDIT,
    DEAL_TYPE_CHARGE,
    DEAL_TYPE_CORRECTION,
    DEAL_TYPE_BONUS,
    DEAL_TYPE_COMMISSION,
    DEAL_TYPE_COMMISSION_DAILY,
    DEAL_TYPE_COMMISSION_MONTHLY,
    DEAL_TYPE_COMMISSION_AGENT_DAILY,
    DEAL_TYPE_COMMISSION_AGENT_MONTHLY,
    DEAL_TYPE_INTEREST,
    DEAL_TYPE_BUY_CANCELED,
    DEAL_TYPE_SELL_CANCELED,
    DEAL_DIVIDEND,
    DEAL_DIVIDEND_FRANKED,
    DEAL_TAX
};
enum ENUM_DEAL_ENTRY
{
    DEAL_ENTRY_IN,
    DEAL_ENTRY_OUT,
    DEAL_ENTRY_INOUT,
    DEAL_ENTRY_OUT_BY
};
enum ENUM_DEAL_REASON
{
    DEAL_REASON_CLIENT,
    DEAL_REASON_MOBILE,
    DEAL_REASON_WEB,
    DEAL_REASON_EXPERT,
    DEAL_REASON_SL,
    DEAL_REASON_TP,
    DEAL_REASON_SO,
    DEAL_REASON_ROLLOVER,
    DEAL_REASON_VMARGIN,
    DEAL_REASON_SPLIT
};
enum ENUM_TRADE_REQUEST_ACTIONS
{
    TRADE_ACTION_DEAL,
    TRADE_ACTION_PENDING,
    TRADE_ACTION_SLTP,
    TRADE_ACTION_MODIFY,
    TRADE_ACTION_REMOVE,
    TRADE_ACTION_CLOSE_BY
};
enum ENUM_TRADE_TRANSACTION_TYPE
{
    TRADE_TRANSACTION_ORDER_ADD,
    TRADE_TRANSACTION_ORDER_UPDATE,
    TRADE_TRANSACTION_ORDER_DELETE,
    TRADE_TRANSACTION_DEAL_ADD,
    TRADE_TRANSACTION_DEAL_UPDATE,
    TRADE_TRANSACTION_DEAL_DELETE,
    TRADE_TRANSACTION_HISTORY_ADD,
    TRADE_TRANSACTION_HISTORY_UPDATE,
    TRADE_TRANSACTION_HISTORY_DELETE,
    TRADE_TRANSACTION_POSITION,
    TRADE_TRANSACTION_REQUEST
};
enum ENUM_BOOK_TYPE
{
    BOOK_TYPE_SELL,
    BOOK_TYPE_BUY,
    BOOK_TYPE_SELL_MARKET,
    BOOK_TYPE_BUY_MARKET
};
enum ENUM_SIGNAL_BASE_DOUBLE
{
    SIGNAL_BASE_BALANCE,
    SIGNAL_BASE_EQUITY,
    SIGNAL_BASE_GAIN,
    SIGNAL_BASE_MAX_DRAWDOWN,
    SIGNAL_BASE_PRICE,
    SIGNAL_BASE_ROI
};
enum ENUM_SIGNAL_BASE_INTEGER
{
    SIGNAL_BASE_DATE_PUBLISHED,
    SIGNAL_BASE_DATE_STARTED,
    SIGNAL_BASE_DATE_UPDATED,
    SIGNAL_BASE_ID,
    SIGNAL_BASE_LEVERAGE,
    SIGNAL_BASE_PIPS,
    SIGNAL_BASE_RATING,
    SIGNAL_BASE_SUBSCRIBERS,
    SIGNAL_BASE_TRADES,
    SIGNAL_BASE_TRADE_MODE
};
enum ENUM_SIGNAL_BASE_STRING
{
    SIGNAL_BASE_AUTHOR_LOGIN,
    SIGNAL_BASE_BROKER,
    SIGNAL_BASE_BROKER_SERVER,
    SIGNAL_BASE_NAME,
    SIGNAL_BASE_CURRENCY
};
enum ENUM_SIGNAL_INFO_DOUBLE
{
    SIGNAL_INFO_EQUITY_LIMIT,
    SIGNAL_INFO_SLIPPAGE,
    SIGNAL_INFO_VOLUME_PERCENT
};
enum ENUM_SIGNAL_INFO_INTEGER
{
    SIGNAL_INFO_CONFIRMATIONS_DISABLED,
    SIGNAL_INFO_COPY_SLTP,
    SIGNAL_INFO_DEPOSIT_PERCENT,
    SIGNAL_INFO_ID,
    SIGNAL_INFO_SUBSCRIPTION_ENABLED,
    SIGNAL_INFO_TERMS_AGREE
};
enum ENUM_SIGNAL_INFO_STRING
{
    SIGNAL_INFO_NAME
};
enum ENUM_POINTER_TYPE
{
    POINTER_INVALID,
    POINTER_DYNAMIC,
    POINTER_AUTOMATIC
};
enum ENUM_CALENDAR_EVENT_TYPE
{
    CALENDAR_TYPE_EVENT,
    CALENDAR_TYPE_INDICATOR,
    CALENDAR_TYPE_HOLIDAY
};
enum ENUM_CALENDAR_EVENT_SECTOR
{
    CALENDAR_SECTOR_NONE,
    CALENDAR_SECTOR_MARKET,
    CALENDAR_SECTOR_GDP,
    CALENDAR_SECTOR_JOBS,
    CALENDAR_SECTOR_PRICES,
    CALENDAR_SECTOR_MONEY,
    CALENDAR_SECTOR_TRADE,
    CALENDAR_SECTOR_GOVERNMENT,
    CALENDAR_SECTOR_BUSINESS,
    CALENDAR_SECTOR_CONSUMER,
    CALENDAR_SECTOR_HOUSING,
    CALENDAR_SECTOR_TAXES,
    CALENDAR_SECTOR_HOLIDAYS
};
enum ENUM_CALENDAR_EVENT_FREQUENCY
{
    CALENDAR_FREQUENCY_NONE,
    CALENDAR_FREQUENCY_WEEK,
    CALENDAR_FREQUENCY_MONTH,
    CALENDAR_FREQUENCY_QUARTER,
    CALENDAR_FREQUENCY_YEAR,
    CALENDAR_FREQUENCY_DAY
};
enum ENUM_CALENDAR_EVENT_TIMEMODE
{
    CALENDAR_TIMEMODE_DATETIME,
    CALENDAR_TIMEMODE_DATE,
    CALENDAR_TIMEMODE_NOTIME,
    CALENDAR_TIMEMODE_TENTATIVE
};
enum ENUM_CALENDAR_EVENT_UNIT
{
    CALENDAR_UNIT_NONE,
    CALENDAR_UNIT_PERCENT,
    CALENDAR_UNIT_CURRENCY,
    CALENDAR_UNIT_HOUR,
    CALENDAR_UNIT_JOB,
    CALENDAR_UNIT_RIG,
    CALENDAR_UNIT_USD,
    CALENDAR_UNIT_PEOPLE,
    CALENDAR_UNIT_MORTGAGE,
    CALENDAR_UNIT_VOTE,
    CALENDAR_UNIT_BARREL,
    CALENDAR_UNIT_CUBICFEET,
    CALENDAR_UNIT_POSITION,
    CALENDAR_UNIT_BUILDING
};
enum ENUM_CALENDAR_EVENT_IMPORTANCE
{
    CALENDAR_IMPORTANCE_NONE,
    CALENDAR_IMPORTANCE_LOW,
    CALENDAR_IMPORTANCE_MODERATE,
    CALENDAR_IMPORTANCE_HIGH
};
enum ENUM_CALENDAR_EVENT_MULTIPLIER
{
    CALENDAR_MULTIPLIER_NONE,
    CALENDAR_MULTIPLIER_THOUSANDS,
    CALENDAR_MULTIPLIER_MILLIONS,
    CALENDAR_MULTIPLIER_BILLIONS,
    CALENDAR_MULTIPLIER_TRILLIONS
};
enum ENUM_CALENDAR_EVENT_IMPACT
{
    CALENDAR_IMPACT_NA,
    CALENDAR_IMPACT_POSITIVE,
    CALENDAR_IMPACT_NEGATIVE
};
struct MqlDateTime
{
    int year;
    int mon;
    int day;
    int hour;
    int min;
    int sec;
    int day_of_week;
    int day_of_year;
};
struct MqlParam
{
    ENUM_DATATYPE type;
    long integer_value;
    double double_value;
    string string_value;
};
struct MqlRates
{
    datetime time;
    double open;
    double high;
    double low;
    double close;
    long tick_volume;
    int spread;
    long real_volume;
};
struct MqlBookInfo
{
    ENUM_BOOK_TYPE type;
    double price;
    long volume;
    double volume_real;
};
struct MqlTradeRequest
{
    ENUM_TRADE_REQUEST_ACTIONS action;
    ulong magic;
    ulong order;
    string symbol;
    double volume;
    double price;
    double stoplimit;
    double sl;
    double tp;
    ulong deviation;
    ENUM_ORDER_TYPE type;
    ENUM_ORDER_TYPE_FILLING type_filling;
    ENUM_ORDER_TYPE_TIME type_time;
    datetime expiration;
    string comment;
    ulong position;
    ulong position_by;
};
struct MqlTradeCheckResult
{
    uint retcode;
    double balance;
    double equity;
    double profit;
    double margin;
    double margin_free;
    double margin_level;
    string comment;
};
struct MqlTradeResult
{
    uint retcode;
    ulong deal;
    ulong order;
    double volume;
    double price;
    double bid;
    double ask;
    string comment;
    uint request_id;
    uint retcode_external;
};
struct MqlTradeTransaction
{
    ulong deal;
    ulong order;
    string symbol;
    ENUM_TRADE_TRANSACTION_TYPE type;
    ENUM_ORDER_TYPE order_type;
    ENUM_ORDER_STATE order_state;
    ENUM_DEAL_TYPE deal_type;
    ENUM_ORDER_TYPE_TIME time_type;
    datetime time_expiration;
    double price;
    double price_trigger;
    double price_sl;
    double price_tp;
    double volume;
    ulong position;
    ulong position_by;
};
struct MqlTick
{
    datetime time;
    double bid;
    double ask;
    double last;
    ulong volume;
    long time_msc;
    uint flags;
    double volume_real;
};
struct MqlCalendarCountry
{
    ulong id;
    string name;
    string code;
    string currency;
    string currency_symbol;
    string url_name;
};
struct MqlCalendarEvent
{
    ulong id;
    ENUM_CALENDAR_EVENT_TYPE type;
    ENUM_CALENDAR_EVENT_SECTOR sector;
    ENUM_CALENDAR_EVENT_FREQUENCY frequency;
    ENUM_CALENDAR_EVENT_TIMEMODE time_mode;
    ulong country_id;
    ENUM_CALENDAR_EVENT_UNIT unit;
    ENUM_CALENDAR_EVENT_IMPORTANCE importance;
    ENUM_CALENDAR_EVENT_MULTIPLIER multiplier;
    uint digits;
    string source_url;
    string event_code;
    string name;
};
struct MqlCalendarValue
{
    ulong id;
    ulong event_id;
    datetime time;
    datetime period;
    int revision;
    long actual_value;
    long prev_value;
    long revised_prev_value;
    long forecast_value;
    ENUM_CALENDAR_EVENT_IMPACT impact_type;
};
enum ENUM_FILE_PROPERTY_INTEGER
{
    FILE_EXISTS,
    FILE_CREATE_DATE,
    FILE_MODIFY_DATE,
    FILE_ACCESS_DATE,
    FILE_SIZE,
    FILE_POSITION,
    FILE_END,
    FILE_LINE_END,
    FILE_IS_COMMON,
    FILE_IS_TEXT,
    FILE_IS_BINARY,
    FILE_IS_CSV,
    FILE_IS_ANSI,
    FILE_IS_READABLE,
    FILE_IS_WRITABLE
};
enum ENUM_CRYPT_METHOD
{
    CRYPT_BASE64,
    CRYPT_AES128,
    CRYPT_AES256,
    CRYPT_DES,
    CRYPT_HASH_SHA1,
    CRYPT_HASH_SHA256,
    CRYPT_HASH_MD5,
    CRYPT_ARCH_ZIP
};
enum ENUM_OPENCL_PROPERTY_INTEGER
{
    CL_DEVICE_COUNT,
    CL_DEVICE_TYPE,
    CL_DEVICE_VENDOR_ID,
    CL_DEVICE_MAX_COMPUTE_UNITS,
    CL_DEVICE_MAX_CLOCK_FREQUENCY,
    CL_DEVICE_GLOBAL_MEM_SIZE,
    CL_DEVICE_LOCAL_MEM_SIZE,
    CL_BUFFER_SIZE,
    CL_DEVICE_MAX_WORK_GROUP_SIZE,
    CL_KERNEL_WORK_GROUP_SIZE,
    CL_KERNEL_LOCAL_MEM_SIZE,
    CL_KERNEL_PRIVATE_MEM_SIZE
};
enum ENUM_CL_DEVICE_TYPE
{
    CL_DEVICE_ACCELERATOR,
    CL_DEVICE_CPU,
    CL_DEVICE_GPU,
    CL_DEVICE_DEFAULT,
    CL_DEVICE_CUSTOM,
};
enum ENUM_OPENCL_HANDLE_TYPE
{
    OPENCL_INVALID,
    OPENCL_CONTEXT,
    OPENCL_PROGRAM,
    OPENCL_KERNEL,
    OPENCL_BUFFER
};
enum ENUM_COLOR_FORMAT
{
    COLOR_FORMAT_XRGB_NOALPHA,
    COLOR_FORMAT_ARGB_RAW,
    COLOR_FORMAT_ARGB_NORMALIZE
};
constexpr int OBJ_NO_PERIODS = 0;
constexpr int OBJ_PERIOD_M1 = 0;
constexpr int OBJ_PERIOD_M2 = 0;
constexpr int OBJ_PERIOD_M3 = 0;
constexpr int OBJ_PERIOD_M4 = 0;
constexpr int OBJ_PERIOD_M5 = 0;
constexpr int OBJ_PERIOD_M6 = 0;
constexpr int OBJ_PERIOD_M10 = 0;
constexpr int OBJ_PERIOD_M12 = 0;
constexpr int OBJ_PERIOD_M15 = 0;
constexpr int OBJ_PERIOD_M20 = 0;
constexpr int OBJ_PERIOD_M30 = 0;
constexpr int OBJ_PERIOD_H1 = 0;
constexpr int OBJ_PERIOD_H2 = 0;
constexpr int OBJ_PERIOD_H3 = 0;
constexpr int OBJ_PERIOD_H4 = 0;
constexpr int OBJ_PERIOD_H6 = 0;
constexpr int OBJ_PERIOD_H8 = 0;
constexpr int OBJ_PERIOD_H12 = 0;
constexpr int OBJ_PERIOD_D1 = 0;
constexpr int OBJ_PERIOD_W1 = 0;
constexpr int OBJ_PERIOD_MN1 = 0;
constexpr int OBJ_ALL_PERIODS = 0;
constexpr int clrAliceBlue = 0;
constexpr int clrAntiqueWhite = 0;
constexpr int clrAqua = 0;
constexpr int clrAquamarine = 0;
constexpr int clrBeige = 0;
constexpr int clrBisque = 0;
constexpr int clrBlack = 0;
constexpr int clrBlanchedAlmond = 0;
constexpr int clrBlue = 0;
constexpr int clrBlueViolet = 0;
constexpr int clrBrown = 0;
constexpr int clrBurlyWood = 0;
constexpr int clrCadetBlue = 0;
constexpr int clrChartreuse = 0;
constexpr int clrChocolate = 0;
constexpr int clrCoral = 0;
constexpr int clrCornflowerBlue = 0;
constexpr int clrCornsilk = 0;
constexpr int clrCrimson = 0;
constexpr int clrDarkBlue = 0;
constexpr int clrDarkGoldenrod = 0;
constexpr int clrDarkGray = 0;
constexpr int clrDarkGreen = 0;
constexpr int clrDarkKhaki = 0;
constexpr int clrDarkOliveGreen = 0;
constexpr int clrDarkOrange = 0;
constexpr int clrDarkOrchid = 0;
constexpr int clrDarkSalmon = 0;
constexpr int clrDarkSeaGreen = 0;
constexpr int clrDarkSlateBlue = 0;
constexpr int clrDarkSlateGray = 0;
constexpr int clrDarkTurquoise = 0;
constexpr int clrDarkViolet = 0;
constexpr int clrDeepPink = 0;
constexpr int clrDeepSkyBlue = 0;
constexpr int clrDimGray = 0;
constexpr int clrDodgerBlue = 0;
constexpr int clrFireBrick = 0;
constexpr int clrForestGreen = 0;
constexpr int clrGainsboro = 0;
constexpr int clrGold = 0;
constexpr int clrGoldenrod = 0;
constexpr int clrGray = 0;
constexpr int clrGreen = 0;
constexpr int clrGreenYellow = 0;
constexpr int clrHoneydew = 0;
constexpr int clrHotPink = 0;
constexpr int clrIndianRed = 0;
constexpr int clrIndigo = 0;
constexpr int clrIvory = 0;
constexpr int clrKhaki = 0;
constexpr int clrLavender = 0;
constexpr int clrLavenderBlush = 0;
constexpr int clrLawnGreen = 0;
constexpr int clrLemonChiffon = 0;
constexpr int clrLightBlue = 0;
constexpr int clrLightCoral = 0;
constexpr int clrLightCyan = 0;
constexpr int clrLightGoldenrod = 0;
constexpr int clrLightGray = 0;
constexpr int clrLightGreen = 0;
constexpr int clrLightPink = 0;
constexpr int clrLightSalmon = 0;
constexpr int clrLightSeaGreen = 0;
constexpr int clrLightSkyBlue = 0;
constexpr int clrLightSlateGray = 0;
constexpr int clrLightSteelBlue = 0;
constexpr int clrLightYellow = 0;
constexpr int clrLime = 0;
constexpr int clrLimeGreen = 0;
constexpr int clrLinen = 0;
constexpr int clrMagenta = 0;
constexpr int clrMaroon = 0;
constexpr int clrMediumAquamarine = 0;
constexpr int clrMediumBlue = 0;
constexpr int clrMediumOrchid = 0;
constexpr int clrMediumPurple = 0;
constexpr int clrMediumSeaGreen = 0;
constexpr int clrMediumSlateBlue = 0;
constexpr int clrMediumSpringGreen = 0;
constexpr int clrMediumTurquoise = 0;
constexpr int clrMediumVioletRed = 0;
constexpr int clrMidnightBlue = 0;
constexpr int clrMintCream = 0;
constexpr int clrMistyRose = 0;
constexpr int clrMoccasin = 0;
constexpr int clrNavajoWhite = 0;
constexpr int clrNavy = 0;
constexpr int clrOldLace = 0;
constexpr int clrOlive = 0;
constexpr int clrOliveDrab = 0;
constexpr int clrOrange = 0;
constexpr int clrOrangeRed = 0;
constexpr int clrOrchid = 0;
constexpr int clrPaleGoldenrod = 0;
constexpr int clrPaleGreen = 0;
constexpr int clrPaleTurquoise = 0;
constexpr int clrPaleVioletRed = 0;
constexpr int clrPapayaWhip = 0;
constexpr int clrPeachPuff = 0;
constexpr int clrPeru = 0;
constexpr int clrPink = 0;
constexpr int clrPlum = 0;
constexpr int clrPowderBlue = 0;
constexpr int clrPurple = 0;
constexpr int clrRed = 0;
constexpr int clrRosyBrown = 0;
constexpr int clrRoyalBlue = 0;
constexpr int clrSaddleBrown = 0;
constexpr int clrSalmon = 0;
constexpr int clrSandyBrown = 0;
constexpr int clrSeaGreen = 0;
constexpr int clrSeashell = 0;
constexpr int clrSienna = 0;
constexpr int clrSilver = 0;
constexpr int clrSkyBlue = 0;
constexpr int clrSlateBlue = 0;
constexpr int clrSlateGray = 0;
constexpr int clrSnow = 0;
constexpr int clrSpringGreen = 0;
constexpr int clrSteelBlue = 0;
constexpr int clrTan = 0;
constexpr int clrTeal = 0;
constexpr int clrThistle = 0;
constexpr int clrTomato = 0;
constexpr int clrTurquoise = 0;
constexpr int clrViolet = 0;
constexpr int clrWheat = 0;
constexpr int clrWhite = 0;
constexpr int clrWhiteSmoke = 0;
constexpr int clrYellow = 0;
constexpr int clrYellowGreen = 0;
constexpr int MAIN_LINE = 0;
constexpr int SIGNAL_LINE = 0;
constexpr int PLUSDI_LINE = 0;
constexpr int MINUSDI_LINE = 0;
constexpr int BASE_LINE = 0;
constexpr int UPPER_BAND = 0;
constexpr int LOWER_BAND = 0;
constexpr int UPPER_LINE = 0;
constexpr int LOWER_LINE = 0;
constexpr int UPPER_HISTOGRAM = 0;
constexpr int LOWER_HISTOGRAM = 0;
constexpr int GATORJAW_LINE = 0;
constexpr int GATORTEETH_LINE = 0;
constexpr int TENKANSEN_LINE = 0;
constexpr int KIJUNSEN_LINE = 0;
constexpr int SENKOUSPANA_LINE = 0;
constexpr int SENKOUSPANB_LINE = 0;
constexpr int CHIKOUSPAN_LINE = 0;
constexpr int SYMBOL_EXPIRATION_GTC = 0;
constexpr int SYMBOL_EXPIRATION_DAY = 0;
constexpr int SYMBOL_EXPIRATION_SPECIFIED = 0;
constexpr int SYMBOL_EXPIRATION_SPECIFIED_DAY = 0;
constexpr int SYMBOL_FILLING_FOK = 0;
constexpr int SYMBOL_FILLING_IOC = 0;
constexpr int SYMBOL_ORDER_MARKET = 0;
constexpr int SYMBOL_ORDER_LIMIT = 0;
constexpr int SYMBOL_ORDER_STOP = 0;
constexpr int SYMBOL_ORDER_STOP_LIMIT = 0;
constexpr int SYMBOL_ORDER_SL = 0;
constexpr int SYMBOL_ORDER_TP = 0;
constexpr int SYMBOL_ORDER_CLOSEBY = 0;
constexpr int TRADE_RETCODE_REQUOTE = 0;
constexpr int TRADE_RETCODE_REJECT = 0;
constexpr int TRADE_RETCODE_CANCEL = 0;
constexpr int TRADE_RETCODE_PLACED = 0;
constexpr int TRADE_RETCODE_DONE = 0;
constexpr int TRADE_RETCODE_DONE_PARTIAL = 0;
constexpr int TRADE_RETCODE_ERROR = 0;
constexpr int TRADE_RETCODE_TIMEOUT = 0;
constexpr int TRADE_RETCODE_INVALID = 0;
constexpr int TRADE_RETCODE_INVALID_VOLUME = 0;
constexpr int TRADE_RETCODE_INVALID_PRICE = 0;
constexpr int TRADE_RETCODE_INVALID_STOPS = 0;
constexpr int TRADE_RETCODE_TRADE_DISABLED = 0;
constexpr int TRADE_RETCODE_MARKET_CLOSED = 0;
constexpr int TRADE_RETCODE_NO_MONEY = 0;
constexpr int TRADE_RETCODE_PRICE_CHANGED = 0;
constexpr int TRADE_RETCODE_PRICE_OFF = 0;
constexpr int TRADE_RETCODE_INVALID_EXPIRATION = 0;
constexpr int TRADE_RETCODE_ORDER_CHANGED = 0;
constexpr int TRADE_RETCODE_TOO_MANY_REQUESTS = 0;
constexpr int TRADE_RETCODE_NO_CHANGES = 0;
constexpr int TRADE_RETCODE_SERVER_DISABLES_AT = 0;
constexpr int TRADE_RETCODE_CLIENT_DISABLES_AT = 0;
constexpr int TRADE_RETCODE_LOCKED = 0;
constexpr int TRADE_RETCODE_FROZEN = 0;
constexpr int TRADE_RETCODE_INVALID_FILL = 0;
constexpr int TRADE_RETCODE_CONNECTION = 0;
constexpr int TRADE_RETCODE_ONLY_REAL = 0;
constexpr int TRADE_RETCODE_LIMIT_ORDERS = 0;
constexpr int TRADE_RETCODE_LIMIT_VOLUME = 0;
constexpr int TRADE_RETCODE_INVALID_ORDER = 0;
constexpr int TRADE_RETCODE_POSITION_CLOSED = 0;
constexpr int TRADE_RETCODE_INVALID_CLOSE_VOLUME = 0;
constexpr int TRADE_RETCODE_CLOSE_ORDER_EXIST = 0;
constexpr int TRADE_RETCODE_LIMIT_POSITIONS = 0;
constexpr int TRADE_RETCODE_REJECT_CANCEL = 0;
constexpr int TRADE_RETCODE_LONG_ONLY = 0;
constexpr int TRADE_RETCODE_SHORT_ONLY = 0;
constexpr int TRADE_RETCODE_CLOSE_ONLY = 0;
constexpr int TRADE_RETCODE_FIFO_CLOSE = 0;
constexpr int ERR_SUCCESS = 0;
constexpr int ERR_INTERNAL_ERROR = 0;
constexpr int ERR_WRONG_INTERNAL_PARAMETER = 0;
constexpr int ERR_INVALID_PARAMETER = 0;
constexpr int ERR_NOT_ENOUGH_MEMORY = 0;
constexpr int ERR_STRUCT_WITHOBJECTS_ORCLASS = 0;
constexpr int ERR_INVALID_ARRAY = 0;
constexpr int ERR_ARRAY_RESIZE_ERROR = 0;
constexpr int ERR_STRING_RESIZE_ERROR = 0;
constexpr int ERR_NOTINITIALIZED_STRING = 0;
constexpr int ERR_INVALID_DATETIME = 0;
constexpr int ERR_ARRAY_BAD_SIZE = 0;
constexpr int ERR_INVALID_POINTER = 0;
constexpr int ERR_INVALID_POINTER_TYPE = 0;
constexpr int ERR_FUNCTION_NOT_ALLOWED = 0;
constexpr int ERR_RESOURCE_NAME_DUPLICATED = 0;
constexpr int ERR_RESOURCE_NOT_FOUND = 0;
constexpr int ERR_RESOURCE_UNSUPPOTED_TYPE = 0;
constexpr int ERR_RESOURCE_NAME_IS_TOO_LONG = 0;
constexpr int ERR_MATH_OVERFLOW = 0;
constexpr int ERR_CHART_WRONG_ID = 0;
constexpr int ERR_CHART_NO_REPLY = 0;
constexpr int ERR_CHART_NOT_FOUND = 0;
constexpr int ERR_CHART_NO_EXPERT = 0;
constexpr int ERR_CHART_CANNOT_OPEN = 0;
constexpr int ERR_CHART_CANNOT_CHANGE = 0;
constexpr int ERR_CHART_WRONG_PARAMETER = 0;
constexpr int ERR_CHART_CANNOT_CREATE_TIMER = 0;
constexpr int ERR_CHART_WRONG_PROPERTY = 0;
constexpr int ERR_CHART_SCREENSHOT_FAILED = 0;
constexpr int ERR_CHART_NAVIGATE_FAILED = 0;
constexpr int ERR_CHART_TEMPLATE_FAILED = 0;
constexpr int ERR_CHART_WINDOW_NOT_FOUND = 0;
constexpr int ERR_CHART_INDICATOR_CANNOT_ADD = 0;
constexpr int ERR_CHART_INDICATOR_CANNOT_DEL = 0;
constexpr int ERR_CHART_INDICATOR_NOT_FOUND = 0;
constexpr int ERR_OBJECT_ERROR = 0;
constexpr int ERR_OBJECT_NOT_FOUND = 0;
constexpr int ERR_OBJECT_WRONG_PROPERTY = 0;
constexpr int ERR_OBJECT_GETDATE_FAILED = 0;
constexpr int ERR_OBJECT_GETVALUE_FAILED = 0;
constexpr int ERR_MARKET_UNKNOWN_SYMBOL = 0;
constexpr int ERR_MARKET_NOT_SELECTED = 0;
constexpr int ERR_MARKET_WRONG_PROPERTY = 0;
constexpr int ERR_MARKET_LASTTIME_UNKNOWN = 0;
constexpr int ERR_MARKET_SELECT_ERROR = 0;
constexpr int ERR_HISTORY_NOT_FOUND = 0;
constexpr int ERR_HISTORY_WRONG_PROPERTY = 0;
constexpr int ERR_HISTORY_TIMEOUT = 0;
constexpr int ERR_HISTORY_BARS_LIMIT = 0;
constexpr int ERR_HISTORY_LOAD_ERRORS = 0;
constexpr int ERR_HISTORY_SMALL_BUFFER = 0;
constexpr int ERR_GLOBALVARIABLE_NOT_FOUND = 0;
constexpr int ERR_GLOBALVARIABLE_EXISTS = 0;
constexpr int ERR_GLOBALVARIABLE_NOT_MODIFIED = 0;
constexpr int ERR_GLOBALVARIABLE_CANNOTREAD = 0;
constexpr int ERR_GLOBALVARIABLE_CANNOTWRITE = 0;
constexpr int ERR_MAIL_SEND_FAILED = 0;
constexpr int ERR_PLAY_SOUND_FAILED = 0;
constexpr int ERR_MQL5_WRONG_PROPERTY = 0;
constexpr int ERR_TERMINAL_WRONG_PROPERTY = 0;
constexpr int ERR_FTP_SEND_FAILED = 0;
constexpr int ERR_NOTIFICATION_SEND_FAILED = 0;
constexpr int ERR_NOTIFICATION_WRONG_PARAMETER = 0;
constexpr int ERR_NOTIFICATION_WRONG_SETTINGS = 0;
constexpr int ERR_NOTIFICATION_TOO_FREQUENT = 0;
constexpr int ERR_FTP_NOSERVER = 0;
constexpr int ERR_FTP_NOLOGIN = 0;
constexpr int ERR_FTP_FILE_ERROR = 0;
constexpr int ERR_FTP_CONNECT_FAILED = 0;
constexpr int ERR_FTP_CHANGEDIR = 0;
constexpr int ERR_FTP_CLOSED = 0;
constexpr int ERR_BUFFERS_NO_MEMORY = 0;
constexpr int ERR_BUFFERS_WRONG_INDEX = 0;
constexpr int ERR_CUSTOM_WRONG_PROPERTY = 0;
constexpr int ERR_ACCOUNT_WRONG_PROPERTY = 0;
constexpr int ERR_TRADE_WRONG_PROPERTY = 0;
constexpr int ERR_TRADE_DISABLED = 0;
constexpr int ERR_TRADE_POSITION_NOT_FOUND = 0;
constexpr int ERR_TRADE_ORDER_NOT_FOUND = 0;
constexpr int ERR_TRADE_DEAL_NOT_FOUND = 0;
constexpr int ERR_TRADE_SEND_FAILED = 0;
constexpr int ERR_TRADE_CALC_FAILED = 0;
constexpr int ERR_INDICATOR_UNKNOWN_SYMBOL = 0;
constexpr int ERR_INDICATOR_CANNOT_CREATE = 0;
constexpr int ERR_INDICATOR_NO_MEMORY = 0;
constexpr int ERR_INDICATOR_CANNOT_APPLY = 0;
constexpr int ERR_INDICATOR_CANNOT_ADD = 0;
constexpr int ERR_INDICATOR_DATA_NOT_FOUND = 0;
constexpr int ERR_INDICATOR_WRONG_HANDLE = 0;
constexpr int ERR_INDICATOR_WRONG_PARAMETERS = 0;
constexpr int ERR_INDICATOR_PARAMETERS_MISSING = 0;
constexpr int ERR_INDICATOR_CUSTOM_NAME = 0;
constexpr int ERR_INDICATOR_PARAMETER_TYPE = 0;
constexpr int ERR_INDICATOR_WRONG_INDEX = 0;
constexpr int ERR_BOOKS_CANNOT_ADD = 0;
constexpr int ERR_BOOKS_CANNOT_DELETE = 0;
constexpr int ERR_BOOKS_CANNOT_GET = 0;
constexpr int ERR_BOOKS_CANNOT_SUBSCRIBE = 0;
constexpr int ERR_TOO_MANY_FILES = 0;
constexpr int ERR_WRONG_FILENAME = 0;
constexpr int ERR_TOO_LONG_FILENAME = 0;
constexpr int ERR_CANNOT_OPEN_FILE = 0;
constexpr int ERR_FILE_CACHEBUFFER_ERROR = 0;
constexpr int ERR_CANNOT_DELETE_FILE = 0;
constexpr int ERR_INVALID_FILEHANDLE = 0;
constexpr int ERR_WRONG_FILEHANDLE = 0;
constexpr int ERR_FILE_NOTTOWRITE = 0;
constexpr int ERR_FILE_NOTTOREAD = 0;
constexpr int ERR_FILE_NOTBIN = 0;
constexpr int ERR_FILE_NOTTXT = 0;
constexpr int ERR_FILE_NOTTXTORCSV = 0;
constexpr int ERR_FILE_NOTCSV = 0;
constexpr int ERR_FILE_READERROR = 0;
constexpr int ERR_FILE_BINSTRINGSIZE = 0;
constexpr int ERR_INCOMPATIBLE_FILE = 0;
constexpr int ERR_FILE_IS_DIRECTORY = 0;
constexpr int ERR_FILE_NOT_EXIST = 0;
constexpr int ERR_FILE_CANNOT_REWRITE = 0;
constexpr int ERR_WRONG_DIRECTORYNAME = 0;
constexpr int ERR_DIRECTORY_NOT_EXIST = 0;
constexpr int ERR_FILE_ISNOT_DIRECTORY = 0;
constexpr int ERR_CANNOT_DELETE_DIRECTORY = 0;
constexpr int ERR_CANNOT_CLEAN_DIRECTORY = 0;
constexpr int ERR_FILE_WRITEERROR = 0;
constexpr int ERR_FILE_ENDOFFILE = 0;
constexpr int ERR_NO_STRING_DATE = 0;
constexpr int ERR_WRONG_STRING_DATE = 0;
constexpr int ERR_WRONG_STRING_TIME = 0;
constexpr int ERR_STRING_TIME_ERROR = 0;
constexpr int ERR_STRING_OUT_OF_MEMORY = 0;
constexpr int ERR_STRING_SMALL_LEN = 0;
constexpr int ERR_STRING_TOO_BIGNUMBER = 0;
constexpr int ERR_WRONG_FORMATSTRING = 0;
constexpr int ERR_TOO_MANY_FORMATTERS = 0;
constexpr int ERR_TOO_MANY_PARAMETERS = 0;
constexpr int ERR_WRONG_STRING_PARAMETER = 0;
constexpr int ERR_STRINGPOS_OUTOFRANGE = 0;
constexpr int ERR_STRING_ZEROADDED = 0;
constexpr int ERR_STRING_UNKNOWNTYPE = 0;
constexpr int ERR_WRONG_STRING_OBJECT = 0;
constexpr int ERR_INCOMPATIBLE_ARRAYS = 0;
constexpr int ERR_SMALL_ASSERIES_ARRAY = 0;
constexpr int ERR_SMALL_ARRAY = 0;
constexpr int ERR_ZEROSIZE_ARRAY = 0;
constexpr int ERR_NUMBER_ARRAYS_ONLY = 0;
constexpr int ERR_ONEDIM_ARRAYS_ONLY = 0;
constexpr int ERR_SERIES_ARRAY = 0;
constexpr int ERR_DOUBLE_ARRAY_ONLY = 0;
constexpr int ERR_FLOAT_ARRAY_ONLY = 0;
constexpr int ERR_LONG_ARRAY_ONLY = 0;
constexpr int ERR_INT_ARRAY_ONLY = 0;
constexpr int ERR_SHORT_ARRAY_ONLY = 0;
constexpr int ERR_CHAR_ARRAY_ONLY = 0;
constexpr int ERR_STRING_ARRAY_ONLY = 0;
constexpr int ERR_OPENCL_NOT_SUPPORTED = 0;
constexpr int ERR_OPENCL_INTERNAL = 0;
constexpr int ERR_OPENCL_INVALID_HANDLE = 0;
constexpr int ERR_OPENCL_CONTEXT_CREATE = 0;
constexpr int ERR_OPENCL_QUEUE_CREATE = 0;
constexpr int ERR_OPENCL_PROGRAM_CREATE = 0;
constexpr int ERR_OPENCL_TOO_LONG_KERNEL_NAME = 0;
constexpr int ERR_OPENCL_KERNEL_CREATE = 0;
constexpr int ERR_OPENCL_SET_KERNEL_PARAMETER = 0;
constexpr int ERR_OPENCL_EXECUTE = 0;
constexpr int ERR_OPENCL_WRONG_BUFFER_SIZE = 0;
constexpr int ERR_OPENCL_WRONG_BUFFER_OFFSET = 0;
constexpr int ERR_OPENCL_BUFFER_CREATE = 0;
constexpr int ERR_OPENCL_TOO_MANY_OBJECTS = 0;
constexpr int ERR_OPENCL_SELECTDEVICE = 0;
constexpr int ERR_DATABASE_INTERNAL = 0;
constexpr int ERR_DATABASE_INVALID_HANDLE = 0;
constexpr int ERR_DATABASE_TOO_MANY_OBJECTS = 0;
constexpr int ERR_DATABASE_CONNECT = 0;
constexpr int ERR_DATABASE_EXECUTE = 0;
constexpr int ERR_DATABASE_PREPARE = 0;
constexpr int ERR_DATABASE_NO_MORE_DATA = 0;
constexpr int ERR_DATABASE_STEP = 0;
constexpr int ERR_DATABASE_NOT_READY = 0;
constexpr int ERR_DATABASE_BIND_PARAMETERS = 0;
constexpr int ERR_WEBREQUEST_INVALID_ADDRESS = 0;
constexpr int ERR_WEBREQUEST_CONNECT_FAILED = 0;
constexpr int ERR_WEBREQUEST_TIMEOUT = 0;
constexpr int ERR_WEBREQUEST_REQUEST_FAILED = 0;
constexpr int ERR_NETSOCKET_INVALIDHANDLE = 0;
constexpr int ERR_NETSOCKET_TOO_MANY_OPENED = 0;
constexpr int ERR_NETSOCKET_CANNOT_CONNECT = 0;
constexpr int ERR_NETSOCKET_IO_ERROR = 0;
constexpr int ERR_NETSOCKET_HANDSHAKE_FAILED = 0;
constexpr int ERR_NETSOCKET_NO_CERTIFICATE = 0;
constexpr int ERR_NOT_CUSTOM_SYMBOL = 0;
constexpr int ERR_CUSTOM_SYMBOL_WRONG_NAME = 0;
constexpr int ERR_CUSTOM_SYMBOL_NAME_LONG = 0;
constexpr int ERR_CUSTOM_SYMBOL_PATH_LONG = 0;
constexpr int ERR_CUSTOM_SYMBOL_EXIST = 0;
constexpr int ERR_CUSTOM_SYMBOL_ERROR = 0;
constexpr int ERR_CUSTOM_SYMBOL_SELECTED = 0;
constexpr int ERR_CUSTOM_SYMBOL_PROPERTY_WRONG = 0;
constexpr int ERR_CUSTOM_SYMBOL_PARAMETER_ERROR = 0;
constexpr int ERR_CUSTOM_SYMBOL_PARAMETER_LONG = 0;
constexpr int ERR_CUSTOM_TICKS_WRONG_ORDER = 0;
constexpr int ERR_CALENDAR_MORE_DATA = 0;
constexpr int ERR_CALENDAR_TIMEOUT = 0;
constexpr int ERR_CALENDAR_NO_DATA = 0;
constexpr int ERR_USER_ERROR_FIRST = 0;
constexpr int FILE_READ = 0;
constexpr int FILE_WRITE = 0;
constexpr int FILE_BIN = 0;
constexpr int FILE_CSV = 0;
constexpr int FILE_TXT = 0;
constexpr int FILE_ANSI = 0;
constexpr int FILE_UNICODE = 0;
constexpr int FILE_SHARE_READ = 0;
constexpr int FILE_SHARE_WRITE = 0;
constexpr int FILE_REWRITE = 0;
constexpr int FILE_COMMON = 0;
constexpr int CP_ACP = 0;
constexpr int CP_OEMCP = 0;
constexpr int CP_MACCP = 0;
constexpr int CP_THREAD_ACP = 0;
constexpr int CP_SYMBOL = 0;
constexpr int CP_UTF7 = 0;
constexpr int CP_UTF8 = 0;
constexpr int IDOK = 0;
constexpr int IDCANCEL = 0;
constexpr int IDABORT = 0;
constexpr int IDRETRY = 0;
constexpr int IDIGNORE = 0;
constexpr int IDYES = 0;
constexpr int IDNO = 0;
constexpr int IDTRYAGAIN = 0;
constexpr int IDCONTINUE = 0;
constexpr int MB_OK = 0;
constexpr int MB_OKCANCEL = 0;
constexpr int MB_ABORTRETRYIGNORE = 0;
constexpr int MB_YESNOCANCEL = 0;
constexpr int MB_YESNO = 0;
constexpr int MB_RETRYCANCEL = 0;
constexpr int MB_CANCELTRYCONTINUE = 0;
constexpr int MB_ICONSTOP = 0;
constexpr int MB_ICONERROR = 0;
constexpr int MB_ICONHAND = 0;
constexpr int MB_ICONQUESTION = 0;
constexpr int MB_ICONEXCLAMATION = 0;
constexpr int MB_ICONWARNING = 0;
constexpr int MB_ICONINFORMATION = 0;
constexpr int MB_ICONASTERISK = 0;
constexpr int MB_DEFBUTTON1 = 0;
constexpr int MB_DEFBUTTON2 = 0;
constexpr int MB_DEFBUTTON3 = 0;
constexpr int MB_DEFBUTTON4 = 0;
constexpr int INT_VALUE = 4;
constexpr int SHORT_VALUE = 2;
constexpr int CHAR_VALUE = 1;
constexpr int COPY_TICKS_INFO = 0;
constexpr int COPY_TICKS_TRADE = 0;
constexpr int COPY_TICKS_ALL = 0;
constexpr int TIME_DATE = 0;
constexpr int TIME_MINUTES = 0;
constexpr int TIME_SECONDS = 0;

double AccountInfoDouble(
	ENUM_ACCOUNT_INFO_DOUBLE property_id
	);
long AccountInfoInteger(
	ENUM_ACCOUNT_INFO_INTEGER property_id
	);
string AccountInfoString(
	ENUM_ACCOUNT_INFO_STRING property_id
	);
double MathArccos(
	double value
	);
double acos(
	double value
	);
template <typename T>
void Alert(
	T argument,
	...
	);
int ArrayBsearch(
	const double array[],
	double value
	);
int ArrayBsearch(
	const float array[],
	float value
	);
int ArrayBsearch(
	const long array[],
	long value
	);
int ArrayBsearch(
	const int array[],
	int value
	);
int ArrayBsearch(
	const short array[],
	short value
	);
int ArrayBsearch(
	const char array[],
	char value
	);
template <typename T>
int ArrayCompare(
	const T array1[],
	const T array2[],
	int start1=0,
	int start2=0,
	int count=WHOLE_ARRAY
	);
template <typename T>
int ArrayCopy(
	T dst_array[],
	const T src_array[],
	int dst_start=0,
	int src_start=0,
	int count=WHOLE_ARRAY
	);
template <typename T>
void ArrayFill(
	T array[],
	int start,
	int count,
	T value
	);
template <typename T>
void ArrayFree(
	T array[]
	);
template <typename T>
bool ArrayGetAsSeries(
	const T array[]
	);
int ArrayInitialize(
	char array[],
	char value
	);
int ArrayInitialize(
	short array[],
	short value
	);
int ArrayInitialize(
	int array[],
	int value
	);
int ArrayInitialize(
	long array[],
	long value
	);
int ArrayInitialize(
	float array[],
	float value
	);
int ArrayInitialize(
	double array[],
	double value
	);
int ArrayInitialize(
	bool array[],
	bool value
	);
int ArrayInitialize(
	uint array[],
	uint value
	);
template <typename T>
bool ArrayIsDynamic(
	const T array[]
	);
template <typename T>
bool ArrayIsSeries(
	const T array[]
	);
template <typename T>
int ArrayMaximum(
	const T array[],
	int start=0,
	int count=WHOLE_ARRAY
	);
template <typename T>
int ArrayMinimum(
	const T array[],
	int start=0,
	int count=WHOLE_ARRAY
	);
template <typename T>
int ArrayRange(
	const T array[],
	int rank_index
	);
template <typename T>
int ArrayResize(
	T array[],
	int new_size,
	int reserve_size=0
	);
template <typename T>
bool ArraySetAsSeries(
	const T array[],
	bool flag
	);
template <typename T>
int ArraySize(
	const T array[]
	);
template <typename T>
bool ArraySort(
	T array[]
	);
double MathArcsin(
	double value
	);
double asin(
	double value
	);
double MathArctan(
	double value
	);
double atan(
	double value
	);
int Bars(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe
	);
int Bars(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	datetime stop_time
	);
int BarsCalculated(
	int indicator_handle
	);
bool CalendarCountryById(
	const long country_id,
	MqlCalendarCountry& country
	);
bool CalendarEventById(
	ulong event_id,
	MqlCalendarEvent& event
	);
bool CalendarValueById(
	ulong value_id,
	MqlCalendarValue& value
	);
int CalendarCountries(
	MqlCalendarCountry countries[]
	);
int CalendarEventByCountry(
	string country_code,
	MqlCalendarEvent events[]
	);
int CalendarEventByCurrency(
	const string currency,
	MqlCalendarEvent events[]
	);
bool CalendarValueHistoryByEvent(
	ulong event_id,
	MqlCalendarValue values[],
	datetime datetime_from,
	datetime datetime_to=0
	);
bool CalendarValueHistory(
	MqlCalendarValue values[],
	datetime datetime_from,
	datetime datetime_to=0,
	const string country_code=NULL,
	const string currency=NULL
	);
int CalendarValueLastByEvent(
	ulong event_id,
	ulong& change_id,
	MqlCalendarValue values[]
	);
int CalendarValueLast(
	ulong& change_id,
	MqlCalendarValue values[],
	const string country_code=NULL,
	const string currency=NULL
	);
double MathCeil(
	double val
	);
double ceil(
	double val
	);
string CharArrayToString(
	uchar array[],
	int start=0,
	int count=-1,
	uint codepage=CP_ACP
	);
bool ChartApplyTemplate(
	long chart_id,
	const string filename
	);
bool ChartClose(
	long chart_id=0
	);
long ChartFirst();
string CharToString(
	uchar char_code
	);
ENUM_TIMEFRAMES ChartPeriod(
	long chart_id=0
	);
double ChartGetDouble(
	long chart_id,
	ENUM_CHART_PROPERTY_DOUBLE prop_id,
	int sub_window=0
	);
bool ChartGetDouble(
	long chart_id,
	ENUM_CHART_PROPERTY_DOUBLE prop_id,
	int sub_window,
	double& double_var
	);
long ChartGetInteger(
	long chart_id,
	ENUM_CHART_PROPERTY_INTEGER prop_id,
	int sub_window=0
	);
bool ChartGetInteger(
	long chart_id,
	ENUM_CHART_PROPERTY_INTEGER prop_id,
	int sub_window,
	long& long_var
	);
string ChartGetString(
	long chart_id,
	ENUM_CHART_PROPERTY_STRING prop_id
	);
bool ChartGetString(
	long chart_id,
	ENUM_CHART_PROPERTY_STRING prop_id,
	string& string_var
	);
long ChartID();
bool ChartIndicatorAdd(
	long chart_id,
	int sub_window,
	int indicator_handle
	);
bool ChartIndicatorDelete(
	long chart_id,
	int sub_window,
	const string indicator_shortname
	);
int ChartIndicatorGet(
	long chart_id,
	int sub_window,
	const string indicator_shortname
	);
string ChartIndicatorName(
	long chart_id,
	int sub_window,
	int index
	);
int ChartIndicatorsTotal(
	long chart_id,
	int sub_window
	);
bool ChartNavigate(
	long chart_id,
	ENUM_CHART_POSITION position,
	int shift=0
	);
long ChartNext(
	long chart_id
	);
long ChartOpen(
	string symbol,
	ENUM_TIMEFRAMES period
	);
string CharToString(
	uchar char_code
	);
datetime ChartTimeOnDropped();
bool ChartTimePriceToXY(
	long chart_id,
	int sub_window,
	datetime time,
	double price,
	int& x,
	int& y
	);
int ChartWindowFind(
	long chart_id,
	string indicator_shortname
	);
int ChartWindowOnDropped();
int ChartXOnDropped();
bool ChartXYToTimePrice(
	long chart_id,
	int x,
	int y,
	int& sub_window,
	datetime& time,
	double& price
	);
double ChartPriceOnDropped();
void ChartRedraw(
	long chart_id=0
	);
bool ChartSaveTemplate(
	long chart_id,
	const string filename
	);
bool ChartScreenShot(
	long chart_id,
	string filename,
	int width,
	int height,
	ENUM_ALIGN_MODE align_mode=ALIGN_RIGHT
	);
bool ChartSetDouble(
	long chart_id,
	ENUM_CHART_PROPERTY_DOUBLE prop_id,
	double value
	);
bool ChartSetInteger(
	long chart_id,
	ENUM_CHART_PROPERTY_INTEGER prop_id,
	long value
	);
bool ChartSetInteger(
	long chart_id,
	ENUM_CHART_PROPERTY_INTEGER prop_id,
	int sub_window,
	long value
	);
bool ChartSetString(
	long chart_id,
	ENUM_CHART_PROPERTY_STRING prop_id,
	string str_value
	);
bool ChartSetSymbolPeriod(
	long chart_id,
	string symbol,
	ENUM_TIMEFRAMES period
	);
string ChartSymbol(
	long chart_id=0
	);
int ChartYOnDropped();
template <typename T>
ENUM_POINTER_TYPE CheckPointer(
	T* anyobject
	);
int CLBufferCreate(
	int context,
	uint size,
	uint flags
	);
void CLBufferFree(
	int buffer
	);
template <typename T>
uint CLBufferRead(
	int buffer,
	const T data[],
	uint buffer_offset=0,
	uint data_offset=0,
	uint data_count=WHOLE_ARRAY
	);
template <typename T>
uint CLBufferWrite(
	int buffer,
	const T data[],
	uint buffer_offset=0,
	uint data_offset=0,
	uint data_count=WHOLE_ARRAY
	);
int CLContextCreate(
	int device
	);
void CLContextFree(
	int context
	);
bool CLExecute(
	int kernel
	);
bool CLExecute(
	int kernel,
	uint work_dim,
	const uint global_work_offset[],
	const uint global_work_size[]
	);
bool CLExecute(
	int kernel,
	uint work_dim,
	const uint global_work_offset[],
	const uint global_work_size[],
	const uint local_work_size[]
	);
bool CLGetDeviceInfo(
	int handle,
	int property_id,
	uchar data[],
	uint& size
	);
long CLGetInfoInteger(
	int handle,
	ENUM_OPENCL_PROPERTY_INTEGER prop
	);
ENUM_OPENCL_HANDLE_TYPE CLHandleType(
	int handle
	);
int CLKernelCreate(
	int program,
	const string kernel_name
	);
void CLKernelFree(
	int kernel
	);
int CLProgramCreate(
	int context,
	const string source
	);
int CLProgramCreate(
	int context,
	const string source,
	string &build_log
	);
int CopyClose(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	int start_pos,
	int count,
	double close_array[]
	);
int CopyClose(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	int count,
	double close_array[]
	);
int CopyClose(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	datetime stop_time,
	double close_array[]
	);
int CopyHigh(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	int start_pos,
	int count,
	double high_array[]
	);
int CopyHigh(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	int count,
	double high_array[]
	);
int CopyHigh(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	datetime stop_time,
	double high_array[]
	);
int CopyLow(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	int start_pos,
	int count,
	double low_array[]
	);
int CopyLow(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	int count,
	double low_array[]
	);
int CopyLow(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	datetime stop_time,
	double low_array[]
	);
int CopyOpen(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	int start_pos,
	int count,
	double open_array[]
	);
int CopyOpen(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	int count,
	double open_array[]
	);
int CopyOpen(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	datetime stop_time,
	double open_array[]
	);
int CopyRates(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	int start_pos,
	int count,
	MqlRates rates_array[]
	);
int CopyRates(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	int count,
	MqlRates rates_array[]
	);
int CopyRates(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	datetime stop_time,
	MqlRates rates_array[]
	);
int CopyRealVolume(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	int start_pos,
	int count,
	long volume_array[]
	);
int CopyRealVolume(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	int count,
	long volume_array[]
	);
int CopyRealVolume(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	datetime stop_time,
	long volume_array[]
	);
int CopySpread(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	int start_pos,
	int count,
	int spread_array[]
	);
int CopySpread(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	int count,
	int spread_array[]
	);
int CopySpread(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	datetime stop_time,
	int spread_array[]
	);
int CopyTicks(
	string symbol_name,
	MqlTick ticks_array[],
	uint flags=COPY_TICKS_ALL,
	ulong from=0,
	uint count=0
	);
int CopyTickVolume(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	int start_pos,
	int count,
	long volume_array[]
	);
int CopyTickVolume(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	int count,
	long volume_array[]
	);
int CopyTickVolume(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	datetime stop_time,
	long volume_array[]
	);
int CopyTime(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	int start_pos,
	int count,
	datetime time_array[]
	);
int CopyTime(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	int count,
	datetime time_array[]
	);
int CopyTime(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	datetime start_time,
	datetime stop_time,
	datetime time_array[]
	);
void CLProgramFree(
	int program
	);
template <typename T>
bool CLSetKernelArg(
	int kernel,
	uint arg_index,
	T arg_value
	);
bool CLSetKernelArgMem(
	int kernel,
	uint arg_index,
	int cl_mem_handle
	);
uint ColorToARGB(
	color clr,
	uchar alpha=255
	);
string ColorToString(
	color color_value,
	bool color_name
	);
template <typename T>
void Comment(
	T argument,
	...
	);
int CopyBuffer(
	int indicator_handle,
	int buffer_num,
	int start_pos,
	int count,
	double buffer[]
	);
int CopyBuffer(
	int indicator_handle,
	int buffer_num,
	datetime start_time,
	int count,
	double buffer[]
	);
int CopyBuffer(
	int indicator_handle,
	int buffer_num,
	datetime start_time,
	datetime stop_time,
	double buffer[]
	);
double MathCos(
	double value
	);
double cos(
	double value
	);
int CryptDecode(
	ENUM_CRYPT_METHOD method,
	const uchar data[],
	const uchar key[],
	uchar result[]
	);
int CryptEncode(
	ENUM_CRYPT_METHOD method,
	const uchar data[],
	const uchar key[],
	uchar result[]
	);
bool CustomSymbolCreate(
	const string symbol_name,
	const string symbol_path="",
	const string symbol_origin=NULL
	);
bool CustomSymbolDelete(
	const string symbol_name
	);
bool CustomSymbolSetInteger(
	const string symbol_name,
	ENUM_SYMBOL_INFO_INTEGER property_id,
	long property_value
	);
bool CustomSymbolSetDouble(
	const string symbol_name,
	ENUM_SYMBOL_INFO_DOUBLE property_id,
	double property_value
	);
bool CustomSymbolSetString(
	const string symbol_name,
	ENUM_SYMBOL_INFO_STRING property_id,
	string property_value
	);
bool CustomSymbolSetMarginRate(
	const string symbol_name,
	ENUM_ORDER_TYPE order_type,
	double initial_margin_rate,
	double maintenance_margin_rate
	);
bool CustomSymbolSetMarginRate(
	const string symbol_name,
	ENUM_ORDER_TYPE order_type,
	double initial_margin_rate,
	double maintenance_margin_rate
	);
bool CustomSymbolSetSessionQuote(
	const string symbol_name,
	ENUM_DAY_OF_WEEK day_of_week,
	uint session_index,
	datetime from,
	datetime to
	);
bool CustomSymbolSetSessionTrade(
	const string symbol_name,
	ENUM_DAY_OF_WEEK day_of_week,
	uint session_index,
	datetime from,
	datetime to
	);
int CustomRatesDelete(
	const string symbol,
	datetime from,
	datetime to
	);
int CustomRatesReplace(
	const string symbol,
	datetime from,
	datetime to,
	const MqlRates rates[],
	uint count=WHOLE_ARRAY
	);
int CustomRatesUpdate(
	const string symbol,
	const MqlRates rates[],
	uint count=WHOLE_ARRAY
	);
int CustomTicksAdd(
	const string symbol,
	const MqlTick ticks[],
	uint count=WHOLE_ARRAY
	);
int CustomTicksDelete(
	const string symbol,
	long from_msc,
	long to_msc
	);
int CustomTicksReplace(
	const string symbol,
	long from_msc,
	long to_msc,
	const MqlTick ticks[],
	uint count=WHOLE_ARRAY
	);
int CustomBookAdd(
	const string symbol,
	const MqlBookInfo books[],
	uint count=WHOLE_ARRAY
	);
void DebugBreak();
int Digits();
string DoubleToString(
	double value,
	int digits=8
	);
string EnumToString(
	int value
	);
bool EventChartCustom(
	long chart_id,
	ushort custom_event_id,
	long lparam,
	double dparam,
	string sparam
	);
void EventKillTimer();
bool EventSetMillisecondTimer(
	int milliseconds
	);
bool EventSetTimer(
	int seconds
	);
double MathExp(
	double value
	);
double exp(
	double value
	);
void ExpertRemove();
double MathAbs(
	double value
	);
double fabs(
	double value
	);
void FileClose(
	int file_handle
	);
bool FileCopy(
	const string src_file_name,
	int common_flag,
	const string dst_file_name,
	int mode_flags
	);
bool FileDelete(
	const string file_name,
	int common_flag=0
	);
void FileFindClose(
	long search_handle
	);
long FileFindFirst(
	const string file_filter,
	string& returned_filename,
	int common_flag=0
	);
bool FileFindNext(
	long search_handle,
	string& returned_filename
	);
void FileFlush(
	int file_handle
	);
long FileGetInteger(
	int file_handle,
	ENUM_FILE_PROPERTY_INTEGER property_id
	);
long FileGetInteger(
	const string file_name,
	ENUM_FILE_PROPERTY_INTEGER property_id,
	bool common_folder=false
	);
bool FileIsEnding(
	int file_handle
	);
bool FileIsExist(
	const string file_name,
	int common_flag=0
	);
bool FileIsLineEnding(
	int file_handle
	);
bool FileMove(
	const string src_file_name,
	int common_flag,
	const string dst_file_name,
	int mode_flags
	);
int FileOpen(
	string file_name,
	int open_flags,
	short delimiter='\t',
	uint codepage=CP_ACP
	);
template <typename T>
uint FileReadArray(
	int file_handle,
	T array[],
	int start=0,
	int count=WHOLE_ARRAY
	);
bool FileReadBool(
	int file_handle
	);
datetime FileReadDatetime(
	int file_handle
	);
double FileReadDouble(
	int file_handle
	);
float FileReadFloat(
	int file_handle
	);
int FileReadInteger(
	int file_handle,
	int size=INT_VALUE
	);
long FileReadLong(
	int file_handle
	);
double FileReadNumber(
	int file_handle
	);
string FileReadString(
	int file_handle,
	int length=-1
	);
template <typename T>
uint FileReadStruct(
	int file_handle,
	const T struct_object,
	int size=-1
	);
bool FileSeek(
	int file_handle,
	long offset,
	ENUM_FILE_POSITION origin
	);
ulong FileSize(
	int file_handle
	);
ulong FileTell(
	int file_handle
	);
uint FileWrite(
	int file_handle,
	...
	);
template <typename T>
uint FileWriteArray(
	int file_handle,
	const T array[],
	int start=0,
	int count=WHOLE_ARRAY
	);
uint FileWriteDouble(
	int file_handle,
	double value
	);
uint FileWriteFloat(
	int file_handle,
	float value
	);
double MathMin(
	double value1,
	double value2
	);
double fmin(
	double value1,
	double value2
	);
double MathMod(
	double value,
	double value2
	);
double fmod(
	double value,
	double value2
	);
bool FolderClean(
	string folder_name,
	int common_flag=0
	);
bool FolderCreate(
	string folder_name,
	int common_flag=0
	);
bool FolderDelete(
	string folder_name,
	int common_flag=0
	);
bool FrameAdd(
	const string name,
	long id,
	double value,
	const string filename
	);
bool FrameFilter(
	const string name,
	long id
	);
bool FrameFirst();
bool FrameInputs(
	ulong pass,
	string parameters[],
	uint& parameters_count
	);
bool FrameNext(
	ulong& pass,
	string& name,
	long& id,
	double& value
	);
uint FileWriteInteger(
	int file_handle,
	int value,
	int size=INT_VALUE
	);
uint FileWriteLong(
	int file_handle,
	long value
	);
uint FileWriteString(
	int file_handle,
	const string text_string,
	int length=-1
	);
template <typename T>
uint FileWriteStruct(
	int file_handle,
	const T& struct_object,
	int size=-1
	);
double MathFloor(
	double value
	);
double floor(
	double value
	);
double MathMax(
	double value1,
	double value2
	);
double fmax(
	double value1,
	double value2
	);
int GetLastError();
template <typename T>
T *GetPointer(
	T &anyobject
	);
uint GetTickCount();
bool GlobalVariableCheck(
	string name
	);
bool GlobalVariableDel(
	string name
	);
double GlobalVariableGet(
	string name
	);
bool GlobalVariableGet(
	string name,
	double& double_var
	);
string GlobalVariableName(
	int index
	);
int GlobalVariablesDeleteAll(
	string prefix_name=NULL,
	datetime limit_data=0
	);
datetime GlobalVariableSet(
	string name,
	double value
	);
bool GlobalVariableSetOnCondition(
	string name,
	double value,
	double check_value
	);
void GlobalVariablesFlush();
int GlobalVariablesTotal();
bool GlobalVariableTemp(
	string name
	);
datetime GlobalVariableTime(
	string name
	);
double HistoryDealGetDouble(
	ulong ticket_number,
	ENUM_DEAL_PROPERTY_DOUBLE property_id
	);
bool HistoryDealGetDouble(
	ulong ticket_number,
	ENUM_DEAL_PROPERTY_DOUBLE property_id,
	double& double_var
	);
long HistoryDealGetInteger(
	ulong ticket_number,
	ENUM_DEAL_PROPERTY_INTEGER property_id
	);
bool HistoryDealGetInteger(
	ulong ticket_number,
	ENUM_DEAL_PROPERTY_INTEGER property_id,
	long& long_var
	);
string HistoryDealGetString(
	ulong ticket_number,
	ENUM_DEAL_PROPERTY_STRING property_id
	);
bool HistoryDealGetString(
	ulong ticket_number,
	ENUM_DEAL_PROPERTY_STRING property_id,
	string& string_var
	);
ulong HistoryDealGetTicket(
	int index
	);
bool HistoryDealSelect(
	ulong ticket
	);
int HistoryDealsTotal();
double HistoryOrderGetDouble(
	ulong ticket_number,
	ENUM_ORDER_PROPERTY_DOUBLE property_id
	);
bool HistoryOrderGetDouble(
	ulong ticket_number,
	ENUM_ORDER_PROPERTY_DOUBLE property_id,
	double& double_var
	);
long HistoryOrderGetInteger(
	ulong ticket_number,
	ENUM_ORDER_PROPERTY_INTEGER property_id
	);
bool HistoryOrderGetInteger(
	ulong ticket_number,
	ENUM_ORDER_PROPERTY_INTEGER property_id,
	long& long_var
	);
string HistoryOrderGetString(
	ulong ticket_number,
	ENUM_ORDER_PROPERTY_STRING property_id
	);
bool HistoryOrderGetString(
	ulong ticket_number,
	ENUM_ORDER_PROPERTY_STRING property_id,
	string& string_var
	);
ulong HistoryOrderGetTicket(
	int index
	);
bool HistoryOrderSelect(
	ulong ticket
	);
int HistoryOrdersTotal();
bool HistorySelect(
	datetime from_date,
	datetime to_date
	);
bool HistorySelectByPosition(
	long position_id
	);
int iAC(
	string symbol,
	ENUM_TIMEFRAMES period
       );
int iAD(
	string symbol,
	ENUM_TIMEFRAMES period,
	ENUM_APPLIED_VOLUME applied_volume
       );
int iADX(
	string symbol,
	ENUM_TIMEFRAMES period,
	int adx_period
	);
int iADXWilder(
	string symbol,
	ENUM_TIMEFRAMES period,
	int adx_period
	);
int iAlligator(
	string symbol,
	ENUM_TIMEFRAMES period,
	int jaw_period,
	int jaw_shift,
	int teeth_period,
	int teeth_shift,
	int lips_period,
	int lips_shift,
	ENUM_MA_METHOD ma_method,
	ENUM_APPLIED_PRICE applied_price
	);
int iAMA(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ama_period,
	int fast_ma_period,
	int slow_ma_period,
	int ama_shift,
	ENUM_APPLIED_PRICE applied_price
	);
int iAO(
	string symbol,
	ENUM_TIMEFRAMES period
       );
int iATR(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ma_period
	);
int iBands(
	string symbol,
	ENUM_TIMEFRAMES period,
	int bands_period,
	int bands_shift,
	double deviation,
	ENUM_APPLIED_PRICE applied_price
	);
int iBearsPower(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ma_period
	);
int iBullsPower(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ma_period
	);
int iBWMFI(
	string symbol,
	ENUM_TIMEFRAMES period,
	ENUM_APPLIED_VOLUME applied_volume
	);
int iCCI(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ma_period,
	ENUM_APPLIED_PRICE applied_price
	);
int iChaikin(
	string symbol,
	ENUM_TIMEFRAMES period,
	int fast_ma_period,
	int slow_ma_period,
	ENUM_MA_METHOD ma_method,
	ENUM_APPLIED_VOLUME applied_volume
	);
int iCustom(
	string symbol,
	ENUM_TIMEFRAMES period,
	string name,
	...
	);
int iDEMA(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ma_period,
	int ma_shift,
	ENUM_APPLIED_PRICE applied_price
	);
int iDeMarker(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ma_period
	);
int iEnvelopes(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ma_period,
	int ma_shift,
	ENUM_MA_METHOD ma_method,
	ENUM_APPLIED_PRICE applied_price,
	double deviation
	);
int iForce(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ma_period,
	ENUM_MA_METHOD ma_method,
	ENUM_APPLIED_VOLUME applied_volume
	);
int iFractals(
	string symbol,
	ENUM_TIMEFRAMES period
	);
int iFrAMA(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ma_period,
	int ma_shift,
	ENUM_APPLIED_PRICE applied_price
	);
int iGator(
	string symbol,
	ENUM_TIMEFRAMES period,
	int jaw_period,
	int jaw_shift,
	int teeth_period,
	int teeth_shift,
	int lips_period,
	int lips_shift,
	ENUM_MA_METHOD ma_method,
	ENUM_APPLIED_PRICE applied_price
	);
int iIchimoku(
	string symbol,
	ENUM_TIMEFRAMES period,
	int tenkan_sen,
	int kijun_sen,
	int senkou_span_b
	);
int iMA(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ma_period,
	int ma_shift,
	ENUM_MA_METHOD ma_method,
	ENUM_APPLIED_PRICE applied_price
       );
int iMACD(
	string symbol,
	ENUM_TIMEFRAMES period,
	int fast_ema_period,
	int slow_ema_period,
	int signal_period,
	ENUM_APPLIED_PRICE applied_price
	);
int iMFI(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ma_period,
	ENUM_APPLIED_VOLUME applied_volume
	);
int iMomentum(
	string symbol,
	ENUM_TIMEFRAMES period,
	int mom_period,
	ENUM_APPLIED_PRICE applied_price
	);
int IndicatorCreate(
	string symbol,
	ENUM_TIMEFRAMES period,
	ENUM_INDICATOR indicator_type,
	int parameters_cnt=0,
	const MqlParam parameters_array[]=NULL
	);
int IndicatorParameters(
	int indicator_handle,
	ENUM_INDICATOR& indicator_type,
	MqlParam parameters[]
	);
bool IndicatorRelease(
	int indicator_handle
	);
bool IndicatorSetDouble(
	ENUM_CUSTOMIND_PROPERTY_DOUBLE prop,
	double prop_value
	);
bool IndicatorSetDouble(
	ENUM_CUSTOMIND_PROPERTY_DOUBLE prop,
	int prop_modifier,
	double prop_value
	);
bool IndicatorSetInteger(
	ENUM_CUSTOMIND_PROPERTY_INTEGER prop,
	int prop_value
	);
bool IndicatorSetInteger(
	ENUM_CUSTOMIND_PROPERTY_INTEGER prop,
	int prop_modifier,
	int prop_value
	);
bool IndicatorSetString(
	ENUM_CUSTOMIND_PROPERTY_STRING prop,
	string prop_value
	);
bool IndicatorSetString(
	ENUM_CUSTOMIND_PROPERTY_STRING prop,
	int prop_modifier,
	string prop_value
	);
string IntegerToString(
	long number,
	int str_len=0,
	ushort fill_symbol=' '
	);
int iOBV(
	string symbol,
	ENUM_TIMEFRAMES period,
	ENUM_APPLIED_VOLUME applied_volume
	);
int iOsMA(
	string symbol,
	ENUM_TIMEFRAMES period,
	int fast_ema_period,
	int slow_ema_period,
	int signal_period,
	ENUM_APPLIED_PRICE applied_price
	);
int iRSI(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ma_period,
	ENUM_APPLIED_PRICE applied_price
	);
int iRVI(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ma_period
	);
int iSAR(
	string symbol,
	ENUM_TIMEFRAMES period,
	double step,
	double maximum
	);
bool IsStopped();
int iStdDev(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ma_period,
	int ma_shift,
	ENUM_MA_METHOD ma_method,
	ENUM_APPLIED_PRICE applied_price
	);
int iStochastic(
	string symbol,
	ENUM_TIMEFRAMES period,
	int Kperiod,
	int Dperiod,
	int slowing,
	ENUM_MA_METHOD ma_method,
	ENUM_STO_PRICE price_field
	);
int iTEMA(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ma_period,
	int ma_shift,
	ENUM_APPLIED_PRICE applied_price
	);
int iTriX(
	string symbol,
	ENUM_TIMEFRAMES period,
	int ma_period,
	ENUM_APPLIED_PRICE applied_price
	);
int iVIDyA(
	string symbol,
	ENUM_TIMEFRAMES period,
	int cmo_period,
	int ema_period,
	int ma_shift,
	ENUM_APPLIED_PRICE applied_price
	);
int iVolumes(
	string symbol,
	ENUM_TIMEFRAMES period,
	ENUM_APPLIED_VOLUME applied_volume
	);
int iWPR(
	string symbol,
	ENUM_TIMEFRAMES period,
	int calc_period
	);
double MathLog(
	double value
	);
double log(
	double value
	);
double MathLog10(
	double val
	);
double log10(
	double val
	);
bool MarketBookAdd(
	string symbol
	);
bool MarketBookGet(
	string symbol,
	MqlBookInfo book[]
	);
bool MarketBookRelease(
	string symbol
	);
double MathAbs(
	double value
	);
double fabs(
	double value
	);
double MathArccos(
	double value
	);
double acos(
	double value
	);
double MathArcsin(
	double value
	);
double asin(
	double value
	);
double MathArctan(
	double value
	);
double atan(
	double value
	);
double MathCeil(
	double val
	);
double ceil(
	double val
	);
double MathCos(
	double value
	);
double cos(
	double value
	);
double exp(
	double value
	);
double MathFloor(
	double value
	);
double floor(
	double value
	);
bool MathIsValidNumber(
	double number
	);
double MathLog(
	double value
	);
double log(
	double value
	);
double MathLog10(
	double val
	);
double log10(
	double val
	);
double MathPow(
	double base,
	double exponent
	);
double pow(
	double base,
	double exponent
	);
int MathRand();
int rand();
double MathRound(
	double value
	);
double round(
	double value
	);
double MathSin(
	double value
	);
double sin(
	double value
	);
double MathSqrt(
	double value
	);
double sqrt(
	double value
	);
void MathSrand(
	int seed
	);
void srand(
	int seed
	);
double MathTan(
	double rad
	);
double tan(
	double rad
	);
int MessageBox(
	string text,
	string caption=NULL,
	int flags=0
	);
int MQLInfoInteger(
	ENUM_MQL_INFO_INTEGER property_id
	);
string MQLInfoString(
	ENUM_MQL_INFO_STRING property_id
	);
double NormalizeDouble(
	double value,
	int digits
	);
bool ObjectCreate(
	long chart_id,
	string name,
	ENUM_OBJECT type,
	int sub_window,
	datetime time1,
	double price1,
	...
	);
bool ObjectDelete(
	long chart_id,
	string name
	);
int ObjectFind(
	long chart_id,
	string name
	);
double ObjectGetDouble(
	long chart_id,
	string name,
	ENUM_OBJECT_PROPERTY_DOUBLE prop_id,
	int prop_modifier=0
	);
bool ObjectGetDouble(
	long chart_id,
	string name,
	ENUM_OBJECT_PROPERTY_DOUBLE prop_id,
	int prop_modifier,
	double& double_var
	);
long ObjectGetInteger(
	long chart_id,
	string name,
	ENUM_OBJECT_PROPERTY_INTEGER prop_id,
	int prop_modifier=0
	);
bool ObjectGetInteger(
	long chart_id,
	string name,
	ENUM_OBJECT_PROPERTY_INTEGER prop_id,
	int prop_modifier,
	long& long_var
	);
string ObjectGetString(
	long chart_id,
	string name,
	ENUM_OBJECT_PROPERTY_STRING prop_id,
	int prop_modifier=0
	);
bool ObjectGetString(
	long chart_id,
	string name,
	ENUM_OBJECT_PROPERTY_STRING prop_id,
	int prop_modifier,
	string& string_var
	);
datetime ObjectGetTimeByValue(
	long chart_id,
	string name,
	double value,
	int line_id
	);
double ObjectGetValueByTime(
	long chart_id,
	string name,
	datetime time,
	int line_id
	);
bool ObjectMove(
	long chart_id,
	string name,
	int point_index,
	datetime time,
	double price
	);
string ObjectName(
	long chart_id,
	int pos,
	int sub_window=-1,
	int type=-1
	);
int ObjectsDeleteAll(
	long chart_id,
	int sub_window=-1,
	int type=-1
	);
int ObjectsDeleteAll(
	long chart_id,
	const string prefix,
	int sub_window=-1,
	int object_type=-1
	);
bool ObjectSetDouble(
	long chart_id,
	string name,
	ENUM_OBJECT_PROPERTY_DOUBLE prop_id,
	double prop_value
	);
bool ObjectSetDouble(
	long chart_id,
	string name,
	ENUM_OBJECT_PROPERTY_DOUBLE prop_id,
	int prop_modifier,
	double prop_value
	);
bool ObjectSetInteger(
	long chart_id,
	string name,
	ENUM_OBJECT_PROPERTY_INTEGER prop_id,
	long prop_value
	);
bool ObjectSetInteger(
	long chart_id,
	string name,
	ENUM_OBJECT_PROPERTY_INTEGER prop_id,
	int prop_modifier,
	long prop_value
	);
bool ObjectSetString(
	long chart_id,
	string name,
	ENUM_OBJECT_PROPERTY_STRING prop_id,
	string prop_value
	);
bool ObjectSetString(
	long chart_id,
	string name,
	ENUM_OBJECT_PROPERTY_STRING prop_id,
	int prop_modifier,
	string prop_value
	);
int ObjectsTotal(
	long chart_id,
	int sub_window=-1,
	int type=-1
	);
bool OrderCalcMargin(
	ENUM_ORDER_TYPE action,
	string symbol,
	double volume,
	double price,
	double& margin
	);
bool OrderCalcProfit(
	ENUM_ORDER_TYPE action,
	string symbol,
	double volume,
	double price_open,
	double price_close,
	double& profit
	);
bool OrderCheck(
	MqlTradeRequest& request,
	MqlTradeCheckResult& result
	);
double OrderGetDouble(
	ENUM_ORDER_PROPERTY_DOUBLE property_id
	);
bool OrderGetDouble(
	ENUM_ORDER_PROPERTY_DOUBLE property_id,
	double& double_var
	);
long OrderGetInteger(
	ENUM_ORDER_PROPERTY_INTEGER property_id
	);
bool OrderGetInteger(
	ENUM_ORDER_PROPERTY_INTEGER property_id,
	long& long_var
	);
string OrderGetString(
	ENUM_ORDER_PROPERTY_STRING property_id
	);
bool OrderGetString(
	ENUM_ORDER_PROPERTY_STRING property_id,
	string& string_var
	);
ulong OrderGetTicket(
	int index
	);
bool OrderSelect(
	ulong ticket
	);
bool OrderSend(
	MqlTradeRequest& request,
	MqlTradeResult& result
	);
bool OrderSendAsync(
	MqlTradeRequest& request,
	MqlTradeResult& result
	);
int OrdersTotal();
bool ParameterGetRange(
	const string name,
	bool& enable,
	long& value,
	long& start,
	long& step,
	long& stop
	);
bool ParameterGetRange(
	const string name,
	bool& enable,
	double& value,
	double& start,
	double& step,
	double& stop
	);
bool ParameterSetRange(
	const string name,
	bool enable,
	long value,
	long start,
	long step,
	long stop
	);
bool ParameterSetRange(
	const string name,
	bool enable,
	double value,
	double start,
	double step,
	double stop
	);
ENUM_TIMEFRAMES Period();
int PeriodSeconds(
	ENUM_TIMEFRAMES period=PERIOD_CURRENT
	);
bool PlaySound(
	string filename
	);
int PlotIndexGetInteger(
	int plot_index,
	ENUM_PLOT_PROPERTY_INTEGER prop
	);
int PlotIndexGetInteger(
	int plot_index,
	ENUM_PLOT_PROPERTY_INTEGER prop,
	int prop_modifier
	);
bool PlotIndexSetDouble(
	int plot_index,
	ENUM_PLOT_PROPERTY_DOUBLE prop,
	double prop_value
	);
bool PlotIndexSetInteger(
	int plot_index,
	ENUM_PLOT_PROPERTY_INTEGER prop,
	int prop_value
	);
bool PlotIndexSetInteger(
	int plot_index,
	ENUM_PLOT_PROPERTY_INTEGER prop,
	int prop_modifier,
	int prop_value
	);
bool PlotIndexSetString(
	int plot_index,
	ENUM_PLOT_PROPERTY_STRING prop_id,
	string prop_value
	);
double Point();
double PositionGetDouble(
	ENUM_POSITION_PROPERTY_DOUBLE property_id
	);
bool PositionGetDouble(
	ENUM_POSITION_PROPERTY_DOUBLE property_id,
	double& double_var
	);
long PositionGetInteger(
	ENUM_POSITION_PROPERTY_INTEGER property_id
	);
bool PositionGetInteger(
	ENUM_POSITION_PROPERTY_INTEGER property_id,
	long& long_var
	);
string PositionGetString(
	ENUM_POSITION_PROPERTY_STRING property_id
	);
bool PositionGetString(
	ENUM_POSITION_PROPERTY_STRING property_id,
	string& string_var
	);
string PositionGetSymbol(
	int index
	);
ulong PositionGetTicket(
	int index
	);
bool PositionSelect(
	string symbol
	);
bool PositionSelectByTicket(
	ulong ticket
	);
int PositionsTotal();
template <typename T>
void Print(
	const T &argument,
	...
	);
void PrintFormat(
	string format_string,
	...
	);
void ResetLastError();
bool ResourceCreate(
	const string resource_name,
	const string path
	);
bool ResourceCreate(
	const string resource_name,
	const uint data[],
	uint img_width,
	uint img_height,
	uint data_xoffset,
	uint data_yoffset,
	uint data_width,
	ENUM_COLOR_FORMAT color_format
	);
bool ResourceFree(
	const string resource_name
	);
bool ResourceReadImage(
	const string resource_name,
	uint data[],
	uint& width,
	uint& height
	);
bool ResourceSave(
	const string resource_name,
	const string file_name
	);
bool SendFTP(
	string filename,
	string ftp_path=NULL
	);
bool SendMail(
	string subject,
	string some_text
	);
bool SendNotification(
	string text
	);
long SeriesInfoInteger(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	ENUM_SERIES_INFO_INTEGER prop_id
	);
bool SeriesInfoInteger(
	string symbol_name,
	ENUM_TIMEFRAMES timeframe,
	ENUM_SERIES_INFO_INTEGER prop_id,
	long& long_var
	);
bool SetIndexBuffer(
	int index,
	double buffer[],
	ENUM_INDEXBUFFER_TYPE data_type
	);
string ShortArrayToString(
	ushort array[],
	int start=0,
	int count=-1
	);
string ShortToString(
	ushort symbol_code
	);
double SignalBaseGetDouble(
	ENUM_SIGNAL_BASE_DOUBLE property_id
	);
long SignalBaseGetInteger(
	ENUM_SIGNAL_BASE_INTEGER property_id
	);
string SignalBaseGetString(
	ENUM_SIGNAL_BASE_STRING property_id
	);
bool SignalBaseSelect(
	int index
	);
int SignalBaseTotal();
double SignalInfoGetDouble(
	ENUM_SIGNAL_INFO_DOUBLE property_id
	);
long SignalInfoGetInteger(
	ENUM_SIGNAL_INFO_INTEGER property_id
	);
string SignalInfoGetString(
	ENUM_SIGNAL_INFO_STRING property_id
	);
bool SignalInfoSetDouble(
	ENUM_SIGNAL_INFO_DOUBLE property_id,
	double value
	);
bool SignalInfoSetInteger(
	ENUM_SIGNAL_INFO_INTEGER property_id,
	long value
	);
bool SignalSubscribe(
	long signal_id
	);
bool SignalUnsubscribe();
void Sleep(
	int milliseconds
	);
int SocketCreate(
	uint flags
	);
bool SocketClose(
	const int socket
	);
bool SocketConnect(
	int socket,
	const string server,
	uint port,
	uint timeout_receive_ms
	);
bool SocketIsConnected(
	const int socket
	);
uint SocketIsReadable(
	const int socket
	);
bool SocketIsWritable(
	const int socket
	);
bool SocketTimeouts(
	int socket,
	uint timeout_send_ms,
	uint timeout_receive_ms
	);
int SocketRead(
	int socket,
	uchar buffer[],
	uint buffer_maxlen,
	uint timeout_ms
	);
int SocketSend(
	int socket,
	const uchar buffer[],
	uint buffer_len
	);
bool SocketTlsHandshake(
	int socket,
	const string host
	);
int SocketTlsCertificate(
	int socket,
	string& subject,
	string& issuer,
	string& serial,
	string& thumbprint,
	datetime& expiration
	);
int SocketTlsRead(
	int socket,
	uchar buffer[],
	uint buffer_maxlen
	);
int SocketTlsReadAvailable(
	int socket,
	uchar buffer[],
	const uint buffer_maxlen
	);
int SocketTlsSend(
	int socket,
	const uchar buffer[],
	uint buffer_len
	);
bool StringAdd(
	string& string_var,
	string add_substring
	);
int StringBufferLen(
	string string_var
	);
int StringCompare(
	const string& string1,
	const string& string2,
	bool case_sensitive=true
	);
template <typename... T>
int StringConcatenate(
	string& string_var,
	T... t
	);
bool StringFill(
	string& string_var,
	ushort character
	);
int StringFind(
	string string_value,
	string match_substring,
	int start_pos=0
	);
string StringFormat(
	string format,
	...
	);
ushort StringGetCharacter(
	string string_value,
	int pos
	);
bool StringInit(
	string& string_var,
	int new_len=0,
	ushort character=0
	);
int StringLen(
	string string_value
	);
int StringReplace(
	string& str,
	const string find,
	const string replacement
	);
bool StringSetCharacter(
	string& string_var,
	int pos,
	ushort character
	);
int StringSplit(
	const string string_value,
	const ushort separator,
	string result[]
	);
string StringSubstr(
	string string_value,
	int start_pos,
	int length=-1
	);
int StringToCharArray(
	string text_string,
	uchar array[],
	int start=0,
	int count=-1,
	uint codepage=CP_ACP
	);
color StringToColor(
	string color_string
	);
double StringToDouble(
	string value
	);
long StringToInteger(
	string value
	);
bool StringToLower(
	string& string_var
	);
int StringToShortArray(
	string text_string,
	ushort array[],
	int start=0,
	int count=-1
	);
datetime StringToTime(
	const string time_string
	);
bool StringToUpper(
	string& string_var
	);
int StringTrimLeft(
	string& string_var
	);
int StringTrimRight(
	string& string_var
	);
datetime StructToTime(
	MqlDateTime& dt_struct
	);
string Symbol();
double SymbolInfoDouble(
	string name,
	ENUM_SYMBOL_INFO_DOUBLE prop_id
	);
long SymbolInfoInteger(
	string name,
	ENUM_SYMBOL_INFO_INTEGER prop_id
	);
bool SymbolInfoInteger(
	string name,
	ENUM_SYMBOL_INFO_INTEGER prop_id,
	long& long_var
	);
bool SymbolInfoMarginRate(
	string name,
	ENUM_ORDER_TYPE order_type,
	double& initial_margin_rate,
	double& maintenance_margin_rate
	);
bool SymbolInfoSessionQuote(
	string name,
	ENUM_DAY_OF_WEEK day_of_week,
	uint session_index,
	datetime& from,
	datetime& to
	);
bool SymbolInfoSessionTrade(
	string name,
	ENUM_DAY_OF_WEEK day_of_week,
	uint session_index,
	datetime& from,
	datetime& to
	);
string SymbolInfoString(
	string name,
	ENUM_SYMBOL_INFO_STRING prop_id
	);
bool SymbolInfoTick(
	string symbol,
	MqlTick& tick
	);
bool SymbolIsSynchronized(
	string name
	);
string SymbolName(
	int pos,
	bool selected
	);
bool SymbolSelect(
	string name,
	bool select
	);
int SymbolsTotal(
	bool selected
	);
bool TerminalClose(
	int ret_code
	);
double TerminalInfoDouble(
	int property_id
	);
int TerminalInfoInteger(
	int property_id
	);
string TerminalInfoString(
	int property_id
	);
double TesterStatistics(
	ENUM_STATISTICS statistic_id
	);
bool TextGetSize(
	const string text,
	uint& width,
	uint& height
	);
bool TextOut(
	const string text,
	int x,
	int y,
	uint anchor,
	uint data[],
	uint width,
	uint height,
	uint color,
	ENUM_COLOR_FORMAT color_format
	);
bool TextSetFont(
	const string name,
	int size,
	uint flags,
	int orientation=0
	);
datetime TimeCurrent();
datetime TimeCurrent(
	MqlDateTime& dt_struct
	);
int TimeDaylightSavings();
datetime TimeGMT();
datetime TimeGMT(
	MqlDateTime& dt_struct
	);
int TimeGMTOffset();
datetime TimeLocal();
datetime TimeLocal(
	MqlDateTime& dt_struct
	);
string TimeToString(
	datetime value,
	int mode=TIME_DATE|TIME_MINUTES
	);
bool TimeToStruct(
	datetime dt,
	MqlDateTime& dt_struct
	);
datetime TimeTradeServer();
datetime TimeTradeServer(
	MqlDateTime& dt_struct
	);
int UninitializeReason();
int WebRequest(
	const string method,
	const string url,
	const string cookie,
	const string referer,
	int timeout,
	const char data[],
	int data_size,
	char result[],
	string &result_headers
	);
int WebRequest(
	const string method,
	const string url,
	const string headers,
	int timeout,
	const char data[],
	char result[],
	string &result_headers
	);
template <typename T>
void ZeroMemory(
	T &variable
	);

#endif

#endif  // VIM_HH
